#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}

const int maxn = 505;

ll x[maxn], y[maxn], r[maxn];

ll cw(const pair < ll, ll > &a, const pair < ll, ll > &b, pair < ll, ll > &c)
{
	return a.fst * (b.snd - c.snd) + b.fst * (c.snd - a.snd) + c.fst * (a.snd - b.snd) > 0;
}

ll ccw(const pair < ll, ll > &a, const pair < ll, ll > &b, pair < ll, ll > &c)
{
	return a.fst * (b.snd - c.snd) + b.fst * (c.snd - a.snd) + c.fst * (a.snd - b.snd) < 0;
}

void hull(vector < pair < ll, ll > > &a)
{
	if (a.size() <= 0)
		return;

	sort(a.begin(), a.end());

	vector < pair < ll, ll > > up, down;
	up.pb(a[0]);
	down.pb(a[0]);
	int n = a.size(); 
	for (int i = 1; i < n; i++)
	{
		if (i == n - 1 || !ccw(a[0], a[i], a[n - 1]))
		{
			while (up.size() > 1 && ccw(up[up.size() - 2], up.back(), a[i]))
				up.pop_back();
			up.pb(a[i]);
		}
		if (i == n - 1 || !cw(a[0], a[i], a[n - 1]))
		{
			while (down.size() > 1 && cw(down[down.size() - 2], down.back(), a[i]))
				down.pop_back();
			down.pb(a[i]);
		}
	}

	a.clear();

	for (auto x : up)
		a.pb(x);
	for (auto x : down)
		a.pb(x);
}

int ans[maxn];

int main()
{
	//gen();
	//freopen("a.in", "r", stdin);


	
	while (true)
	{
		int n;
		scanf("%d", &n);

		if (!n)
			break;

		ll m = 0;

		for (int i = 0; i < n; i++)
		{
			scanf("%lld %lld %lld", x + i, y + i, r + i);
			m = max(m, r[i]);
		}

		if (m == 0)
		{
			for (int i = 0; i < n; i++)
				printf("0");
			printf("\n");
			continue;
		}

		vector < pair < ll, ll > > a;
		map < pair < ll, ll >, int > cnt;
	
		for (int i = 0; i < n; i++)
		{
			ans[i] = 0;

			

			if (r[i] == m)
			{
				a.pb(mp(x[i], y[i]));
				cnt[mp(x[i], y[i])]++;
			}
		}

		hull(a);

		set < pair < ll, ll > > s;
		for (auto x : a)
			s.insert(x);



		for (int i = 0; i < n; i++)
		{
			if (r[i] == m && s.count(mp(x[i], y[i])) && cnt[mp(x[i], y[i])] == 1)
				ans[i] = 1;
		}

		for (int i = 0; i < n; i++)
			printf("%d", ans[i]);
		printf("\n");
	}

	return 0;
}