#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const int maxn = 2050;
const int mod = 998244353;
void add(int& x, int y) {
	x += y;
	if (x >= mod) x -= mod;
}

void sub(int& x, int y) {
	x -= y;
	if (x < 0) x += mod;
}

void mul(int& x, int y) {
	x = x*(ll)y%mod;
}

int getpow(int x, int n) {
	int res = 1;
	int t = x;
	while (n) {
		if (n&1) mul(res, t);
		mul(t, t);
		n >>= 1;
	}
	return res;
}

int dp[maxn];

int pw(int st) {
	int res = 1;
	forn(i, st) add(res, res);
	return res;
}

int rev[maxn];
int cnt[25];

int inv[maxn];


bool solve() {
	int n; scanf("%d", &n);
	if (n == 0) return false;
	memset(dp,0,sizeof(dp));
	memset(cnt,0,sizeof(cnt));
	dp[0] = 1;
	vector<int> a(n);
	forn(i, n) scanf("%d", &a[i]);
	int bad = 0;
	forn(ii, n) {
		int cur = a[ii];
		if (rev[cur] == -1) bad++;
		else cnt[rev[cur]]++;
	}
	for (int st = 0; st <= 12; ++st) {
		int curp = (1<<st);
		for (int i = 2048; i >= 0; --i) {
			int curcomb = cnt[st];
			for (int cc = 1, toi = i-curp; cc <= cnt[st] && toi >= 0; ++cc, toi-=curp) {
				//int toi = i-cc*(1<<st);
				//if (toi < 0) break;
				int mult = dp[toi];
				mul(mult, curcomb);
				add(dp[i], mult);

				int diff = cnt[st];
				sub(diff, cc);
				mul(diff, inv[cc+1]);
				mul(curcomb, diff);
			}
		}
	}
	/*forn(ii, n) {
		int cur = a[ii];
		if (cur > 0 && (cur&(cur-1))==0) {
			for (int i = 2048; i >= cur; --i) add(dp[i], dp[i-cur]);
		} else bad++;
	}*/
	int ans = pw(n);
	int mult = pw(bad);
	forn(i, 2048) {
		sub(ans, (dp[i] * (ll)mult)%mod);
	}
	printf("%d\n", ans);
	return true;
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	for (int i = 1; i < maxn; ++i) inv[i] = getpow(i, mod-2);
	memset(rev,-1,sizeof(rev));
	for (int i = 0, pp = 1; pp <= 2048; ++i, pp *= 2) rev[pp] = i;
	while (solve());
	return 0;
}
