#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

struct point {
	int x, y;
	point():x(0),y(0) {}
	point(int x, int y):x(x),y(y) {}
	point operator+(const point& o) const {
		return point(x+o.x,y+o.y);
	}
	point operator-(const point& o) const {
		return point(x-o.x,y-o.y);
	}
	ll operator*(const point& o) const {
		return x*(ll)o.y-y*(ll)o.x;
	}
	ll operator%(const point& o) const {
		return x*(ll)o.x+y*(ll)o.y;
	}
	ll length() const {
		return *this % *this;
	}
	bool operator<(const point& o) const {
		return mp(x,y) < mp(o.x,o.y);
	}
};

bool cmp(const point& p1, const point& p2) {
	ll vv = p1 * p2;
	if (vv > 0) return 1;
	if (vv < 0) return false;
	if (vv == 0) return p1.length() < p2.length();
}


bool solve() {
	int n; scanf("%d", &n);
	if (n == 0) return false;
	vector<pair<point, int> > pts(n);
	int mx = -1;
	forn(i, n) scanf("%d%d%d", &pts[i].X.x,&pts[i].X.y,&pts[i].Y), mx = max(mx, pts[i].Y);
	if (mx == 0) {
		forn(i, n) printf("0");
		printf("\n");
		return true;
	}
	set<point> used;
	vector<point> v;
	forn(i, n) if (pts[i].Y == mx && !used.count(pts[i].X)) v.pb(pts[i].X), used.insert(pts[i].X);
	pii mn = mp(v[0].x,v[0].y);
	forn(i, sz(v)) mn = min(mn, mp(v[i].x,v[i].y));
	forn(i, sz(v)) v[i].x -= mn.X, v[i].y -= mn.Y;
	sort(ALL(v),cmp);
	vector<point> st;
	st.pb(v[0]);
	for(int i = 1; i < sz(v); ++i) {
		point cur = v[i];
		while (sz(st) > 1) {
			point pr = st.back();
			point ppr = st[sz(st)-2];
			if ((pr-ppr)*(cur-pr) < 0) st.pop_back();
			else break;
		}
		st.push_back(cur);
	}
	st.pb(st[0]);
	set<point> good;
	forn(i, sz(st)) good.insert(st[i]);
	forn(i, sz(v)) {
		bool ok = false;
		forn(j, sz(st)-1) {
			point p1 = st[j];
			point p2 = st[j+1];
			if ((p2-p1)*(v[i]-p1) == 0) {ok = true; break;}
		}
		if (ok) good.insert(v[i]);
	}
	forn(i, n) if (good.count(pts[i].X)) printf("1"); else printf("0");
	printf("\n");
	return true;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	while (solve());
	return 0;
}
