#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)5e2+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n;
int a[maxn], x[maxn], y[maxn];
int ans[maxn];

bool cmp(int i, int j){
	if ( x[i] == x[j] ) return y[i] < y[j];
	return x[i] < x[j];
}

bool cw(int i, int j, int k){
	int ax = x[j]-x[i];
	int ay = y[j]-y[i];
	int bx = x[k]-x[i];
	int by = y[k]-y[i];
	return ax*by - ay*bx < 0;
}

bool ccw(int i, int j, int k){
	int ax = x[j]-x[i];
	int ay = y[j]-y[i];
	int bx = x[k]-x[i];
	int by = y[k]-y[i];
	return ax*by - ay*bx > 0;
}

void convex_hull(vector <int> &v){
	if ( sz(v) < 3 ){
		forit(it, v)
			ans[*it] = true;
		return;
	}
	vector <int> up;
	vector < int> down;
	up.pb(0);
	down.pb(0);

	for (int i=1;i<sz(v);i++){
		if ( i == sz(v) - 1 || ccw(0, sz(v)-1, v[i]) ){
			int cur = sz(up);
			while ( sz(up) >= 2 && !cw(up[cur-2], up[cur-1], v[i]) ){
				up.pop_back();
				cur--;
			}
			up.pb(v[i]);
		}
		if ( i == sz(v) - 1 || cw(0, sz(v)-1, v[i])){
			int cur = sz(down);
			while ( cur >= 2 && !ccw(down[cur-2], down[cur-1], v[i]) ){
				down.pop_back();
				cur--;
			}
			down.pb(v[i]);
		}
	}

	forit(it, up){
		ans[*it] = true;
	}
	forit(it, down)
		ans[*it] = true;

}

bool Solve(){
    scanf("%d", &n);
	if ( !n ) return false;

    int maxi = -inf;
    for (int i=0;i<n;i++){
    	scanf("%d%d%d", &x[i], &y[i], &a[i]);
    	maxi = max(maxi, a[i]);
    }

    vector < int > v;
    for (int i=0;i<n;i++){
		if ( a[i] == maxi)
			v.pb(i);
    }

    sort(all(v), cmp);
    memset(ans, 0, sizeof(ans));
    convex_hull(v);

    for (int i=0;i<n;i++){
    	printf("%d", ans[i]);
    }
    printf("\n");
 	return true;
}


int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	while(Solve());

	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
