#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)5e2+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

struct Point {
	double x, y;
	int ind;
	
	Point () {}
	Point (double x, double y) : x(x), y(y) {}

	void read(int _ind) {
		ind = _ind;
		cin >> x >> y;
	}

	double dist(Point o) {
		return sqrt(sqr(o.x - x) + sqr(o.y - y));
	}
	Point const operator +(Point o) {
		return Point(x + o.x, y + o.y);
	}
	Point const operator -(Point o) {
		return Point(x - o.x, y - o.y);
	}
	Point const operator *(double k) {
		return Point(x * k, y * k);
	}
	Point const operator /(double k) {
		return Point(x / k, y / k);
	}
} a[maxn];

struct Line {
	double a, b, c;

	Line () {}
	Line (double a, double b, double c) : a(a), b(b), c(c) {}
	Line (Point p, Point q) {
		a = p.y - q.y;
		b = -(p.x - q.x);
		c = -(a * p.x + b * p.y);
	}

	int sgn(Point p) {
		double val = a * p.x + b * p.y + c;
		if(val > 0) return 1;
		if(val < 0) return -1;
		return 0;
	}

	Line const operator *(double k) {
		return Line(a * k, b * k, c * k);
	}

	bool parralel(Line o) {
		double d = a * o.b - b * o.a;
		return abs(d) < 1e-9;
	}

	Point intersect(Line o) {
		double a1 = a, b1 = b, c1 = c;
		double a2 = o.a, b2 = o.b, c2 = o.c;
		double d = a1 * b2 - a2 * b1;
		double x = c2 * b1 - b2 * c1;
		double y = a2 * c1 - a1 * c2;
		return Point(x / d, y / d);
	}
};

Line perp(Line l, Point m) {
	Line ans = Line(-l.b, l.a, 0);
	ans.c = -(ans.a * m.x + ans.b * m.y);
	return ans;
}

int n;
int vt[maxn];
int ans[maxn];
vector <Point> v;
vector <Line> d;

bool cmp(Line a, Line b) {
	Point va = Point(a.a, a.b);
	Point vb = Point(b.a, b.b);
	return atan2(va.x, va.y) < atan2(vb.x, vb.y);
	return va.x < vb.x || (abs(va.x - vb.x) < 1e-9 && va.y < vb.y);
}

bool equals(Line a, Line b) {
	double d = a.a * b.b - a.b * b.a;
	return abs(d) < 1e-9;
}

int process() {
	Line f1 = Line(Point(-inf, -inf), Point(inf, -inf));
	Line f2 = Line(Point(-inf, inf), Point(-inf, -inf));
	Line f3 = Line(Point(-inf, inf), Point(inf, inf));
	Line f4 = Line(Point(inf, inf), Point(inf, -inf));
	d.pb(f1);
	d.pb(f2);
	d.pb(f3);
	d.pb(f4);
	sort(all(d), cmp);

	stack <Line> st;

	for(int i = 0; i < sz(d); i++) {
		if(st.size() < 2) st.push(d[i]);
		else {
			while(st.size() >= 2) {
				Line last = st.top(); st.pop();
				Line prevlast = st.top(); st.pop();
				if(last.parralel(prevlast)) {
					st.push(prevlast);
					continue;
				}
				Point temp = last.intersect(prevlast);
				if(d[i].sgn(temp) == -1) {
					st.push(prevlast);
				} else break;
			}
			st.push(d[i]);
		}
	}

	vector <Line> temp;

	while(!st.empty()) {
		temp.pb(st.top());
		st.pop();
	}

	for(int i = 0; i < sz(temp); i++) {
		if(equals(temp[i], f1)) return 1;
		if(equals(temp[i], f2)) return 1;
		if(equals(temp[i], f3)) return 1;
		if(equals(temp[i], f4)) return 1;
	}

	return 0;
}

bool Solve(){
    scanf("%d", &n);
	if ( !n ) return false;

	for(int i = 0; i < n; i++) {
		a[i].read(i);
		scanf("%d", vt + i);
	}

	int mx = *max_element(vt, vt + n);

	for(int i = 0; i < n; i++) ans[i] = 0;

	v.clear();
	for(int i = 0; i < n; i++)
		if(vt[i] == mx) v.pb(a[i]);

	for(int i = 0; i < sz(v); i++) {
		d.clear();
		bool ok = 1;
		for(int j = 0; j < sz(v); j++) {
			if(j == i) continue;
			if(v[i].dist(v[j]) < 1e-9) {
				ans[v[i].ind] = 0;
				ok = 0;
				break;
			}
			Line l = Line(v[i], v[j]);
			Point mid = (v[i] + v[j]);
			mid = mid / 2.0;
			Line cur = perp(l, mid);
			if(cur.sgn(v[i]) != 1) cur = cur * (-1.0);
			d.pb(cur);
		}
		if(!ok) continue;
		ans[v[i].ind] = process();
	}

	for (int i=0;i<n;i++){
		printf("%d", ans[i]);
	}
	printf("\n");


 	return true;
}


int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	while(Solve());

	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
