#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
#include <cassert>
#include <ctime>
#include <utility>
#include <queue>

using namespace std;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define fname ""

typedef long long LL;
typedef pair<int,int> pii;

const int maxn = (int)1e5 + 10;
const int inf = (int)1e9;
const int mod = 998244353;
const double eps = 1e-9;

bool was[2049][2049], used[2049];
int d[2049][2049], cnt[2049], f[maxn], rf[maxn], a[maxn], n;

int bin_pow(int x, int n) {
	if (!n)
		return 1;
	if (n % 2)
		return x * 1ll * bin_pow(x, n - 1) % mod;
	x = bin_pow(x, n / 2);
	return x * 1ll * x % mod;
}

int rev(int x) {
	return bin_pow(x, mod - 2);
}

int c(int n, int k) {
	return f[n] * 1ll * rf[k] % mod * 1ll * rf[n - k] % mod;
}

int calc(int x, int k) {
	if (was[x][k])
		return d[x][k];
	was[x][k] = true;
	if (x == 1) {
		if (cnt[x] < k)
			return 0;
		for (int i = k; i <= cnt[x]; ++i)
			d[x][k] = (d[x][k] + c(cnt[x], i)) % mod;
		return d[x][k];
	}
	for (int i = 0; i <= cnt[x]; ++i)
		d[x][k] = (d[x][k] + c(cnt[x], i) * 1ll * calc(x / 2, max(0, (k - i) * 2))) % mod;
	return d[x][k];
} 

void init() {
	for (int i = 0; i <= 2048; ++i) {
		cnt[i] = 0;
		for (int j = 0; j <= 2048; ++j)
			d[i][j] = was[i][j] = 0;
	}
}

int main() {
//	freopen(fname"in", "r", stdin);
//	freopen(fname"out", "w", stdout);

	for (int i = 1; i <= 2048; i *= 2)
		used[i] = true;

	f[0] = 1;
	rf[0] = rev(f[0]);
	for (int i = 1; i < maxn; ++i) {
		f[i] = f[i - 1] * 1ll * i % mod;
		rf[i] = rev(f[i]);
	}

	int k = 0;
	while (true) {
		scanf("%d", &n);
		if (!n)
			break;
		k = 0;
		for (int i = 1; i <= n; ++i) {
			scanf("%d", &a[i]);
			cnt[a[i]]++;
			if (!used[a[i]])
				++k;
		}

		printf("%d\n", calc(2048, 1) * bin_pow(2, k) % mod);

		init();
	}

	return 0;
}
