#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
#include <cassert>
#include <ctime>
#include <utility>
#include <queue>

using namespace std;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define fname ""

typedef long long LL;
typedef pair<int,int> pii;

const int maxn = (int)11;
const int maxmask = (1 << 20);
const short int inf = 300;
const int mod = (int)1e9 + 7;
const double eps = 1e-9;

bool top, mid, bottom;
short int d[maxn][maxn][maxmask], n, m;
char s[maxn][maxn];

int press(short int ok, short int u, short int v, int mask) {
	top = (mask & (1 << v));
	mid = (mask & (1 << (v + m)));
	if (u + 1 < n && s[u + 1][v] == '1')
		bottom = 1;
	else
		bottom = 0;

	mask ^= (top << v);
	mask ^= (mid << (v + m));

	if (ok == 0) {
		if (v - 1 >= 0)
			mask ^= (1 << (v - 1));
		if (v + 1 < m)
			mask ^= (1 << (v + m + 1));
		bottom ^= 1;
		top ^= 1;
	}
	if (ok == 1) {
		if (v - 1 >= 0)
			mask ^= (1 << (v - 1));
		if (v + 1 < m)
			mask ^= (1 << (v + m + 1));
		bottom ^= 1;
		top ^= 1;
		mid ^= 1;
	}
	if (ok == 3)
		mid ^= 1;

	mask |= (mid << v);
	mask |= (bottom << (v + m));
	return mask;
}

void print(int mask) {
	for (short int i = 0; i < m; ++i)
		if ((mask & (1 << i)))
			cerr << 1;
		else
			cerr << 0;
	cerr << '\n';
	for (short int i = 0; i < m; ++i)
		if ((mask & (1 << (i + m))))
			cerr << 1;
		else
			cerr << 0;
	cerr << '\n';
	return;
}

short int calc(short int u, short int v, int mask) {
	if (d[u][v][mask] != -1)
		return d[u][v][mask];
	short int &res = d[u][v][mask] = inf;
	if (u >= n) {
		if (!mask)
			res = 0;
		return res;
	}
	if (v >= m)
		return res = calc(u + 1, 0, mask);
	int new_mask;
	if (u == 0 || (mask & (1 << v))) {
		new_mask = press(0, u, v, mask);
		res = min(res, (short int)(calc(u, v + 1, new_mask) + 1));
		new_mask = press(1, u, v, mask);
		res = min(res, (short int)(calc(u, v + 1, new_mask) + 1));
	}
	if (u == 0 || !(mask & (1 << v))) {
		new_mask = press(2, u, v, mask);
		res = min(res, calc(u, v + 1, new_mask));
		new_mask = press(3, u, v, mask);
		res = min(res, (short int)(calc(u, v + 1, new_mask) + 2));
	}
	return res;
}

void solve() {
	cin >> n >> m;
	if (!n)
		exit(0);
	int mask = 0;
	for (short int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j)
			cin >> s[i][j];
		if (!i)
			for (short int j = 0; j < m; ++j)
				mask |= ((s[i][j] - '0') << (j + m));
	}
	cout << calc(0, 0, mask) << '\n';     
	return;
}

void init() {
	for (short int i = 0; i <= n; ++i)
		for (short int j = 0; j <= m; ++j)
			for (int mask = 0; mask < (1 << (m + m)); ++mask)
				d[i][j][mask] = -1;
	return;
}

int main() {
//	freopen(fname"in", "r", stdin);
//	freopen(fname"out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	while (true) {
		n = 10, m = 10;
		init();
		solve();
	}

	return 0;
}
