#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "j"

const int mod = 998244353;
const int g = 3;
int mainroot = 996173970;
int invroot = 121392023;

inline int mul(int a, int b)
{
	return ll(a) * ll(b) % mod;
}

inline int add(int a, int b)
{
	int x = a + b;
	if (x >= mod) x -= mod;
	return x;
}

inline int sub(int a, int b)
{
	int x = a - b;
	if (x < 0) x += mod;
	return x;
}

inline int power(int a, int d)
{
	int ans = 1;
	for (int cur = a; d; d >>= 1, cur = mul(cur, cur))
		if (d & 1) 
			ans = mul(ans, cur);
	return ans;
}

struct poly
{
	vector<int> a;
	
	poly(int s): a(s) 
	{
	}
	
	int sz() const
	{
		return a.size();
	}
	
	void extend(int s)
	{
		assert(sz() <= s);
		a.resize(s);
	}
	
	int& operator [] (int idx)
	{
		return a[idx];
	}
	
	void print()
	{
#ifdef LOCAL
		for (int i = 0; i < sz(); ++i)
			cerr << a[i] << " ";
		cerr << endl;
#endif
	}
};

const int maxn = 110000;
const int maxdeg = 1 << 19;

int roots[maxdeg], invroots[maxdeg];
int rbits[maxdeg], subf[maxn + maxn];

#define root AnatoliyVasserman

inline int root(int deg, int ord)
{
	if (ord > 0)
		return roots[(maxdeg / deg) * ord];
	else
		return invroots[-(maxdeg / deg) * ord];
}

void fft(poly &a, bool inv)
{
//	cerr << "FFT" << endl;
//	a.print();
	int n = a.sz();
	for (int i = 0; i < n; ++i)
		if (rbits[i] < i)
			swap(a[rbits[i]], a[i]);
//	a.print();
	for (int len = 2; len <= n; len *= 2)
	{
//		cerr << "LEN = " << len << endl;
		for (int i = 0; i < n; i += len)
		{
			int sgn = inv ? -1 : 1;
			for (int j = 0; j < len / 2; ++j)
			{
				int u = a[i + j], v = mul(a[i + j + len / 2], root(len, sgn * j));
//				cerr << "ROOT = " << root(len, sgn * j) << endl;
//				cerr << u << " " << v << endl;
				a[i + j] = add(u, v);
				a[i + j + len / 2] = sub(u, v);
			}
		}
//		a.print();
	}
	if (inv)
	{
		int d = power(n, mod - 2);
		for (int i = 0; i < n; ++i)
			a[i] = mul(a[i], d);
	}
}

void precalc(int n)
{
	rbits[0] = 0;
	int logn = 0;
	for (int x = n; x > 1; x >>= 1) ++logn;
	for (int i = 1; i < n; ++i)
		rbits[i] = (rbits[i >> 1] >> 1) | ((i & 1) << (logn - 1));
}

poly operator * (poly &a, poly &b)
{
//	cerr << "MUL" << endl;
//	a.print();
//	b.print();
	int anssz = a.sz() + b.sz();
	while (anssz & (anssz - 1)) anssz++;
	precalc(anssz);
	poly res(anssz);
	a.extend(anssz);
	b.extend(anssz);
	fft(a, false);
	fft(b, false);
//	a.print();
//	b.print();
	for (int i = 0; i < anssz; ++i)
		res[i] = mul(a[i], b[i]);
	fft(res, true);
//	cerr << "RES = ";
//	res.print();
	return res;
}

int n, m, a[maxn];

poly mulall(int l, int r)
{
	if (l == r)
	{
		poly res(2);
		res[0] = a[l];
		res[1] = 1;
		return res;
	}
	int m = (l + r) / 2;
	poly p = mulall(l, m);
	poly q = mulall(m + 1, r);
	return p * q;
}

bool solve()
{
	scanf("%d%d", &n, &m);
	if (n == 0 && m == 0) return false;
	for (int i = 0; i < n; ++i)
		scanf("%d", &a[i]);
	poly res = mulall(0, n - 1);
	reverse(res.a.begin(), res.a.begin() + n + 1);
//	for (int i = 0; i <= n; ++i)
//		cerr << res[i] << " ";
//	cerr << endl;
	poly s(n + m);
	for (int i = 0; i < n + m; ++i)
		s[i] = subf[i];
	poly ans = s * res;
	for (int i = n; i < n + m; ++i)
		cout << ans[i] << endl;
	return true;
}

void precalc()
{
	mainroot = power(g, (mod - 1) / maxdeg);
	invroot = power(mainroot, mod - 2);
	assert(mul(mainroot, invroot) == 1);
	assert(maxdeg >= 3 * maxn);
	roots[0] = 1;
	roots[1] = mainroot;
	invroots[0] = 1;
	invroots[1] = invroot;
	for (int i = 2; i < maxdeg; ++i)
		roots[i] = mul(roots[i - 1], mainroot),
		invroots[i] = mul(invroots[i - 1], invroot);

	subf[0] = 1;
	for (int i = 1; i < maxn + maxn; ++i)
		subf[i] = add(mul(i, subf[i - 1]), (i % 2 == 0 ? 1 : mod - 1));
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	//freopen("out.txt", "w", stdout);
	#endif // LOCAL
	precalc();
	while (solve());
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
