#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>

using namespace std;

#define sqr(x) ((x)*(x))

class point{
public:
    int x, y, ind, v;
    point() {}
    point(int _x, int _y) {
        x = _x;
        y = _y;
    }
    bool operator<(const point & a) const {
        return (ind < a.ind);
    }
    point operator-(const point & a) const {
        return point(x - a.x, y - a.y);
    }
    int operator%(const point & p) {
        return x * p.x + y * p.y;
    }
    int operator*(const point & p) {
        return y * p.x - x * p.y;
    }
    int distTo2(const point & p) {
        return sqr(x - p.x) + sqr(y - p.y);
    }
};

vector<point> a;

int my = 1e9;
int mx = 1e9;
point mp;

bool cmp(const point & a, const point & b) {
//    cerr << a.x << " " << a.y << " " << b.x << " " << b.y << " " << (a - mp) * (b - mp) << endl;
    if ((a - mp) * (b - mp) == 0) {
//        cerr << mp.distTo2(a) << " " << mp.distTo2(b) << endl;
        return mp.distTo2(a) < mp.distTo2(b);
    }
    return (a - mp) * (b - mp) < 0;
}

vector<point> buildConvex() {
    my = 1e9;
    mx = 1e9;
    int ind = -1;

    for (int i = 0; i < a.size(); ++i) {
        if (a[i].y < my) my = a[i].y, mx = a[i].x, ind = i;
        if (a[i].y == my && mx > a[i].x) mx = a[i].x, ind = i;
    }

    swap(a[0], a[ind]);

    mp = point(mx, my);


    sort(a.begin() + 1, a.end(), cmp);

/*    for (int i = 0; i < a.size(); ++i)
        cerr << a[i].x << " " << a[i].y << endl;
    cerr << "___________\n";*/
/*
    cerr << "_______" << endl;
    for (int i = 0; i < a.size(); ++i)
        cerr << a[i].x << " " << a[i].y << " " << a[i].ind << endl;
    cerr << "_______" << endl;
*/
    vector<point> st;
    st.push_back(a[0]);

    for (int i =  1; i < a.size(); ++i) {
//        cerr << a[i].x << " " << a[i].y << " " << (st[st.size() - 1] - st[st.size() - 2]) * (a[i] - st[st.size() - 1]) << "\n";
        while (st.size() > 1 && (st[st.size() - 1] - st[st.size() - 2]) * (a[i] - st[st.size() - 1]) > 0) {
//            cerr << st[st.size() - 1].x << " " << st[st.size() - 1].y << endl;
            st.pop_back();
        }
        st.push_back(a[i]);
    }

//    cerr << st.size() << endl;

     while (st.size() > 1 && (st[st.size() - 1] - st[st.size() - 2]) * (a[0] - st[st.size() - 1]) > 0)
        st.pop_back();

//    cerr << st.size() << endl;

    return st;
}


int main()
{
    ios_base::sync_with_stdio(false);
    while (true) {
        int n;
        cin >> n;
        if (n == 0) break;
        vector<point> b;
        a.clear();
        b.resize(n);
        int max_v = -1;
        for (int i = 0; i < n; ++i) {
            cin >> b[i].x >> b[i].y >> b[i].v;
            max_v = max(max_v, b[i].v);
            b[i].ind = i;
        }

        for (int i = 0; i < n; ++i)
            if (b[i].v == max_v)
                a.push_back(b[i]);

//        cerr << "Here" << endl;

        vector<point> ans = buildConvex();

//        cerr << "Here" << endl;

        vector<bool> ans_v(n);
//        if (max_v != 0)
            for (int i = 0; i < ans.size(); ++i)
                ans_v[ans[i].ind] = true;
        for (int i = 0; i < n; ++i)
            for (int j = i + 1; j < n; ++j) {
                if (b[i].v == max_v && b[j].v == max_v && b[i].x == b[j].x && b[i].y == b[j].y)
                    ans_v[i] = ans_v[j] = false;
            }
        for (int i = 0; i < n; ++i)
            cout << ans_v[i];
        cout << "\n";
    }
    return 0;
}
