#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <ctime>

using namespace std;

#define sqr(x) ((x)*(x))

class point{
public:
    long long x, y, ind, v;
    point() {}
    point(long long _x, long long _y) {
        x = _x;
        y = _y;
    }
    bool operator<(const point & a) const {
        return (ind < a.ind);
    }
    point operator-(const point & a) const {
        return point(x - a.x, y - a.y);
    }
    long long operator%(const point & p) {
        return x * p.x + y * p.y;
    }
    long long operator*(const point & p) {
        return y * p.x - x * p.y;
    }
    long long distTo2(const point & p) {
        return sqr(x - p.x) + sqr(y - p.y);
    }
};

vector<point> a;

int my = 1e9;
int mx = 1e9;
point mp;

bool cmp(const point & a, const point & b) {
//    cerr << a.x << " " << a.y << " " << b.x << " " << b.y << " " << (a - mp) * (b - mp) << endl;
    if ((a - mp) * (b - mp) == 0) {
        if (a.x > mp.x)
            return mp.distTo2(a) < mp.distTo2(b);
        else return mp.distTo2(a) > mp.distTo2(b);
    }
    return (a - mp) * (b - mp) < 0;
}

vector<point> buildConvex() {
    my = 1e9;
    mx = 1e9;
    int ind = -1;

    for (int i = 0; i < a.size(); ++i) {
        if (a[i].y < my) my = a[i].y, mx = a[i].x, ind = i;
        if (a[i].y == my && mx > a[i].x) mx = a[i].x, ind = i;
    }

    swap(a[0], a[ind]);

    mp = point(mx, my);


    sort(a.begin() + 1, a.end(), cmp);

/*    for (int i = 0; i < a.size(); ++i)
        cerr << a[i].x << " " << a[i].y << endl;
    cerr << "___________\n";*/
/*
    cerr << "_______" << endl;
    for (int i = 0; i < a.size(); ++i)
        cerr << a[i].x << " " << a[i].y << " " << a[i].ind << endl;
    cerr << "_______" << endl;
*/
    vector<point> st;
    st.push_back(a[0]);

    for (int i =  1; i < a.size(); ++i) {
//        cerr << a[i].x << " " << a[i].y << " " << (st[st.size() - 1] - st[st.size() - 2]) * (a[i] - st[st.size() - 1]) << "\n";
        while (st.size() > 1 && (st[st.size() - 1] - st[st.size() - 2]) * (a[i] - st[st.size() - 1]) > 0) {
//            cerr << st[st.size() - 1].x << " " << st[st.size() - 1].y << endl;
            st.pop_back();
        }
        st.push_back(a[i]);
    }

//    cerr << st.size() << endl;

     while (st.size() > 1 && (st[st.size() - 1] - st[st.size() - 2]) * (a[0] - st[st.size() - 1]) > 0)
        st.pop_back();
/*
    for (int i = 0; i < st.size(); ++i)
        if (i + 2 < st.size() && (st[i + 2] - st[i]) * (st[i + 1] - st[i]) == 0)
            st.erase(st.begin() + i + 1), --i;
*/
//    cerr << st.size() << endl;

    return st;
}

vector<point> generatePoints(int n) {
    vector<point> res(n);
    for (int i = 0; i < n; ++i) {
//        res[i].x = rand() % int(2 * 1e4) - 1e4;
//        res[i].y = rand() % int(2 * 1e4) - 1e4;
        res[i].x = i / 3;
        res[i].y = i % 3;
        res[i].v = 5;
        res[i].ind = i;
    }
    return res;
}

int main()
{
    srand(time(0));
    ios_base::sync_with_stdio(false);
    while (true) {
        int n;
        cin >> n;
        if (n == 0) break;
        vector<point> b(n);
//        vector<point> b = generatePoints(n);
        a.clear();
        b.resize(n);
        long long max_v = -1;
        for (int i = 0; i < n; ++i) {
            cin >> b[i].x >> b[i].y >> b[i].v;
//            cerr << b[i].x << " " << b[i].y << endl;
            max_v = max(max_v, b[i].v);
            b[i].ind = i;
        }

        for (int i = 0; i < n; ++i)
            if (b[i].v == max_v)
                a.push_back(b[i]);

        vector<point> ans = buildConvex();

        vector<bool> ans_v(n, false);
        if (max_v != 0)
            for (int i = 0; i < ans.size(); ++i)
                ans_v[ans[i].ind] = true;
        for (int i = 0; i < n; ++i)
            for (int j = i + 1; j < n; ++j) {
                if (b[i].v == max_v && b[j].v == max_v && b[i].x == b[j].x && b[i].y == b[j].y)
                    ans_v[i] = ans_v[j] = false;
            }

        for (int i = 0; i < n; ++i) {
            //if (ans_v[i]) cerr << b[i].x << " " << b[i].y << endl;
            cout << ans_v[i];
        }
        cout << "\n";
    }
    return 0;
}
