#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <ctime>

using namespace std;

#define sqr(x) ((x)*(x))

class point{
public:
    long long x, y, ind, v;
    point() {}
    point(long long _x, long long _y) {
        x = _x;
        y = _y;
    }
//    bool operator<(const point & a) const {
//        return (ind < a.ind);
//    }
    point operator-(const point & a) const {
        return point(x - a.x, y - a.y);
    }
    long long operator%(const point & p) {
        return x * p.x + y * p.y;
    }
    long long operator*(const point & p) {
        return x * p.y - y * p.x;
    }
    long long distTo2(const point & p) {
        return sqr(x - p.x) + sqr(y - p.y);
    }
};

vector<point> a;

int my = 1e9;
int mx = 1e9;
point mp;

bool cmp2(const point & a, const point & b) {
    if (a.x == b.x)
        return a.y < b.y;
    return a.x < b.x;
}

vector<point> buildConvex2() {
    sort(a.begin(), a.end(), cmp2);

    point left(1e9, 1e9), right(-1e9, -1e9);

    for (int i = 0; i < a.size(); ++i) {
        if (a[i].x < left.x)
            left = a[i];
        if (a[i].x >= right.x)
            right = a[i];
    }

    vector<point> st_up, st_low;
    st_up.push_back(left);
    st_low.push_back(left);

    for (int i = 0; i < a.size(); ++i) {
        if (a[i].ind == left.ind || a[i].ind == right.ind) continue;
        if ((right - left) * (a[i] - left) < 0) {
            while (st_up.size() > 1 && (st_up[st_up.size() - 1] - st_up[st_up.size() - 2]) * (a[i] - st_up[st_up.size() - 1]) < 0)
                st_up.pop_back();
            st_up.push_back(a[i]);
        } else if ((right - left) * (a[i] - left) > 0) {
            while (st_low.size() > 1 && (st_low[st_low.size() - 1] - st_low[st_low.size() - 2]) * (a[i] - st_low[st_low.size() - 1]) > 0)
                st_low.pop_back();
            st_low.push_back(a[i]);
        }
    }

    if (st_up.size() == 1) {
        for (int i = 0; i < a.size(); ++i)
            if ((right - left) * (a[i] - left) == 0)
                st_up.push_back(a[i]);
    } else
    if (st_low.size() == 1)
        for (int i = 0; i < a.size(); ++i)
            if ((right - left) * (a[i] - left) == 0)
                st_low.push_back(a[i]);


    while (st_up.size() > 1 && (st_up[st_up.size() - 1] - st_up[st_up.size() - 2]) * (right - st_up[st_up.size() - 1]) < 0)
        st_up.pop_back();
    if (left.ind != right.ind)
        st_up.push_back(right);
    while (st_low.size() > 1 && (st_low[st_low.size() - 1] - st_low[st_low.size() - 2]) * (right - st_low[st_low.size() - 1]) > 0)
        st_low.pop_back();

    for (int i = 1; i < st_low.size(); ++i)
        st_up.push_back(st_low[i]);

    return st_up;
}



vector<point> generatePoints(int n) {
    vector<point> res(n);
    for (int i = 0; i < n; ++i) {
//        res[i].x = rand() % int(2 * 1e4) - 1e4;
//        res[i].y = rand() % int(2 * 1e4) - 1e4;
        res[i].x = i / 6;
        res[i].y = i % 6;
        res[i].v = 1;
        res[i].ind = i;
    }
    return res;
}

int main()
{
    srand(time(0));
    ios_base::sync_with_stdio(false);
    while (true) {
        int n;
        cin >> n;
        if (n == 0) break;
//        vector<point> b(n);
        vector<point> b = generatePoints(n);
        a.clear();
        b.resize(n);
        long long max_v = -1;
        for (int i = 0; i < n; ++i) {
//            cin >> b[i].x >> b[i].y >> b[i].v;
            cerr << b[i].x << " " << b[i].y << " " << b[i].v << endl;
            max_v = max(max_v, b[i].v);
            b[i].ind = i;
        }

        cerr << "___________________________\n";

        for (int i = 0; i < n; ++i)
            if (b[i].v == max_v)
                a.push_back(b[i]);

        vector<point> ans = buildConvex2();

        vector<bool> ans_v(n, false);
        if (max_v != 0)
            for (int i = 0; i < ans.size(); ++i)
                ans_v[ans[i].ind] = true;
        for (int i = 0; i < n; ++i)
            for (int j = i + 1; j < n; ++j) {
                if (b[i].v == max_v && b[j].v == max_v && b[i].x == b[j].x && b[i].y == b[j].y)
//                    ans_v[i] = ans_v[j] = false;
                    ans_v[j] = false;
            }

        cerr << b.size() << endl;

        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            if (ans_v[i]) cerr << i << " " << b[i].x << " " << b[i].y << endl, ++cnt;
//            cout << ans_v[i];
        }
        cout << "\n";
//        cerr << cnt << endl;
    }
    return 0;
}
