#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

const int MAXVAL = 2048;
const int MAXN = 100000;
const ll MODULO = 998244353;

int n;
int howMuch[MAXVAL + 1];
int d[MAXVAL + 2][MAXVAL + 1];

ll factorials[MAXN + 1], revs[MAXN + 1];

ll mult(ll a, ll b) {
	return (a * b) % MODULO;
}

void add(int & a, int b) {
	a += b;
	if(a >= MODULO)
		a -= MODULO;
}

ll getPow(ll a, ll p) {
	ll result = 1;
	while(p != 0) {
		if((p & 1) != 0)
			result = mult(result, a);
		a = mult(a, a);
		p >>= 1;
	}
	return result;
}

void precalc() {
	factorials[0] = factorials[1] = 1;
	for(int i = 2; i <= MAXN; i++) {
		factorials[i] = mult(factorials[i - 1], i);
	}
	for(int i = 0; i <= MAXN; i++) {
		revs[i] = getPow(factorials[i], MODULO - 2);
		assert(mult(factorials[i], revs[i]) == 1);
	}
}

ll C(ll k, ll n) {
	assert(k <= n && n <= MAXN);
	return mult(factorials[n], mult(revs[k], revs[n - k]));
}

bool solve() {
	memset(howMuch, 0, sizeof(howMuch));
	memset(d, 0, sizeof(d));
	scanf("%d", &n);
	if(n == 0)
		return false;
	for(int i = 0; i < n; i++) {
		int value;
		scanf("%d", &value);
		++howMuch[value];
	}
	d[0][0] = 1;
	
	for(int last = 0; last <= MAXVAL; last++) {
		for(int sum = 0; sum <= MAXVAL; sum++) {
			int cur = d[last][sum];
			int inc = (last == 0 ? 1 : 2);
			
			if(cur != 0) {
				for(int take = 0; take <= howMuch[last]; take++) {
					int maxCanJoin = take;
					if(last != 0 && maxCanJoin % 2 != 0)
						--maxCanJoin;
					int newSum = min(MAXVAL, sum + maxCanJoin * last);
					assert(sum <= newSum);
					add(d[last + 1][newSum], mult(cur, C(take, howMuch[last])));
				}
			}
		}
	}
	
	int result = d[MAXVAL + 1][MAXVAL];
	printf("%d\n", result);
	return true;
}

int main() {
	precalc();
	while(solve())
		;
	return 0;
}