import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;


public class Main {
	static class MyReader {
		BufferedInputStream in;

		final int bufSize = 1 << 16;
		final byte b[] = new byte[bufSize];

		MyReader( InputStream in ) {
			this.in = new BufferedInputStream(in, bufSize);
		}

		int nextInt() throws IOException {
			int c;
			while ((c = nextChar()) <= 32)
				;
			int x = 0, sign = 1;
			if (c == '-') {
				sign = -1;
				c = nextChar();
			}
			while (c >= '0') {
				x = x * 10 + (c - '0');
				c = nextChar();
			}
			return x * sign;
		}

		StringBuilder _buf = new StringBuilder();
		String nextWord() throws IOException {
			int c;
			_buf.setLength(0);
			while ((c = nextChar()) <= 32)
				;
			while (c > 32) {
				_buf.append((char)c);
				c = nextChar();
			}
			return _buf.toString();
		}

		int bn = bufSize, k = bufSize;
		
		int nextChar() throws IOException {
			if (bn == k) {
				k = in.read(b, 0, bufSize);
					bn = 0;
			}
			return bn >= k ? -1 : b[bn++];
		}

		int nextNotSpace() throws IOException {
			int ch;
			while ((ch = nextChar()) <= 32 && ch != -1)
				;
			return ch;
		}
	}

	
	static double sqr(double a) {
		return a*a;
	}
	
	static boolean doubleEqual(double a, double b) {
		return Math.abs(a-b) < 1e-9;
	}
	
	static boolean doubleLessOrEqual(double a, double b) {
		return a<b || doubleEqual(a, b);
	}
	
	static boolean doubleLess(double a, double b) {
		return a<b && !doubleEqual(a, b);
	}
	
	static boolean doubleGreaterOrEqual(double a, double b) {
		return a>b || doubleEqual(a, b);
	}
	
	static boolean doubleGreater(double a, double b) {
		return a>b && !doubleEqual(a, b);
	}
	
	static double mySqrt(double a) {
		if (doubleLess(a, 0)) {
			throw new RuntimeException("sqrt(-1)");
		}
		if (a<0) return 0;
		return Math.sqrt(a);
	}
	
	static class Point {
		public int x;
		public int y;
		public int index;
		
		public Point(int x, int y, int index) {
			this.x = x;
			this.y = y;
			this.index = index;
		}
		
		public Point(int index) {
			this(0, 0, index);
		}
		
		public Point add(Point p) {
			return new Point(x + p.x, y + p.y, index);
		}
		
		public Point sub(Point p) {
			return new Point(x - p.x, y - p.y, index);
		}
		
		public Point minus() {
			return new Point(-x, -y, index);
		}
		
		public Point mul(int k) {
			return new Point(x*k, y*k, index);
		}
		
		
		public int scalarProduct(Point p) {
			return x*p.x + y*p.y;
		}
		
		public int vectorProduct(Point p) {
			return x*p.y - y*p.x;
		}
		
		public int lengthSquare() {
			return this.scalarProduct(this);
		}
		
		public double getAngle(Point u) {
			Point v = this;
			//return Math.atan2(v.vectorProduct(u), v.scalarProduct(u));
			return ((double)(v.vectorProduct(u))) / ((double)(v.scalarProduct(u)));
		}
	}
	
	static Point[] pointsstatic = new Point[500];
	static boolean[] isinf = new boolean[500];
	static int[]x=new int[500];
	static int[]y=new int[500];
	static int[]v=new int[500];
	
	static void vobl(int size) {
		if (size <= 3) {
			for (int i=0;i<size;++i) isinf[pointsstatic[i].index] = true;
			return;
		}
		
		int left = 0;
		for (int i=0; i<size; ++i) {
			if (pointsstatic[left].x > pointsstatic[i].x) {
				left = i;
			} else if (pointsstatic[left].x == pointsstatic[i].x) {
				if (pointsstatic[left].y > pointsstatic[i].y) {
					left = i;
				}
			}
		}
		
		isinf[pointsstatic[left].index] = true;
		Point i0 = pointsstatic[left];
		Point i = i0;
		
		Point prevpryamaya = new Point(1, 0, -1);
		
		int count = 1000;
		while (--count > 0) {
			double angle = Double.MAX_VALUE;
			int curlen = Integer.MAX_VALUE;
			Point p = null;
			for (int iter = 0; iter < size; ++iter) {
				Point point = pointsstatic[iter];
				if (point != i) {
					double curangle = point.sub(i).getAngle(prevpryamaya);
					if (doubleLess(curangle, angle)) {
						angle = curangle;
						p = point;
						curlen = p.sub(i).lengthSquare();
					} else if (doubleEqual(curangle, angle)) {
						int trylen = point.sub(i).lengthSquare();
						//System.out.println(trylen+" "+curlen);
						if (trylen < curlen) {
							curlen = trylen;
							angle = curangle;
							p = point;
						}
					}
				}
			}
			if (count <= 0) throw new RuntimeException();
			prevpryamaya = p.sub(i);
			i = p;
			if (i==i0) break;
			isinf[i.index] = true;
		}
	}
	
	static public void main(String... args) throws IOException {
		MyReader in = new MyReader(System.in);
		/*if(true) {
			int n = in.nextInt();
			for (int i=0;i<n;++i) {
				pointsstatic[i] = new Point(in.nextInt(), in.nextInt(), i);
			}
			vobl(n);
			for (int i=0;i<n;++i) if (isinf[i]) {Point pp = pointsstatic[i];
				System.out.println(pp.x+" "+pp.y);
			}
		}*/
		while (true) {
			int n = in.nextInt();
			if (n==0) return;
			int maxv = -1;
			for (int i=0;i<n;++i) {
				x[i]=in.nextInt();
				y[i]=in.nextInt();
				v[i]=in.nextInt();
				if (maxv < v[i]) maxv = v[i];
				isinf[i] = false;
			}
			int size = 0;
			for (int i=0;i<n;++i) {
				if (v[i]==maxv) {
					pointsstatic[size++]=new Point(x[i], y[i], i);
				}
			}
			vobl(size);
			StringBuilder b = new StringBuilder(n);
			for (int i=0;i<n;++i) b.append(isinf[i]?'1':'0');
			System.out.println(b);
		}
	}
}
