#include <iostream>
using namespace std;


long long GCD(long long a, long long b)
{
    while (a > 0 && b > 0) {
        if (a >= b) {
            a %= b;
        } else {
            b %= a;
        }
    }
    return a + b;
}

long long LCM(long long a, long long b)
{
    return a / GCD(a, b) * b;
}

const long long kMaxItr = 1e5;

long long GetNext(long long x, long long k)
{
    return k * (x / k + (x % k != 0));
}

long long GetValue(long long x, long long k)
{
    for (long long i = 1; i <= k; ++i) {
        x = GetNext(x, i);
    }
    return x;
}

long long FastGetValue(long long x)
{
    if (x <= 1) {
        return 1;
    }

    long long lcm = 1;
    long long i = 1;

    while (lcm < x) {
        ++i;
        lcm = LCM(lcm, i);
    }

    return x * (i - 1);
}

long long FastGetValue(long long x, long long k)
{
    if (k == 1) {
        return x;
    }

    if ((k & 1) == 1) {
        return GetNext(FastGetValue(x, k - 1), k);
    } else {
        long long new_x = FastGetValue(x, k >> 1);

        if (new_x <= 2 * x) {
            for (long long i = 1; i <= k; ++i) {
                x = GetNext(x, i);
            }
            return x;
        } else {
            return new_x * 2;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);

    long long x, k;
    while (cin >> x >> k) {
        if (x == 0 && k == 0) {
            break;
        }
        cout << FastGetValue(x, k) << endl;
    }

    return 0;
}
