#include<iostream>
#include<stdio.h>
#include<algorithm>
using namespace std;

int sqr(int n) { return n*n; }


struct TPoint
{
	int x,y,n;
	TPoint(int _x=0,int _y=0) { x=_x; y=_y; n=-1; }
	bool operator< (const TPoint &p) const
	{
		if(x!=p.x) return x<p.x;
		return y<p.y;
	}
	int operator* (const TPoint &p) const { return x*p.y-y*p.x; }
	void operator-= (const TPoint &p) { x-=p.x; y-=p.y; }
	int length() const { return sqr(x)+sqr(y); }
};

bool cmp(const TPoint &a, const TPoint &b)
{
	if((a*b)==0) return a.length()>b.length();
	return (a*b)<0;
}


bool check(TPoint a,TPoint b,TPoint c)
{
	b-=a;	c-=a;
	return (b*c)>0;
}

TPoint p[1000],m[1000];
int v[1000];


int convHULL(int N)
{
	if(N==0) return 0;
	int i,cnt=0;
	TPoint pt = p[0];
	for(i=0;i<N;i++)
		if(p[i]<pt) pt=p[i];
	for(i=0;i<N;i++) p[i]-=pt;
	sort(p,p+N,cmp);
	p[N++]=p[0];
	m[cnt++]=p[0];
	if(N==2) return 1;
	m[cnt++]=p[1];
	for(i=2;i<N;i++)
	{
		while(cnt>=2 && check(m[cnt-2],m[cnt-1],p[i])) 
		{
			cnt--;
		}
		m[cnt++]=p[i];
	}
	return cnt;
}

bool flag[1000];
void solve(int N)
{
	int i,j,mv=-1;
	int M = N;
	for(i=0;i<N;i++)
	{
		flag[i]=false;
		scanf("%d%d%d",&p[i].x,&p[i].y,&v[i]);
		p[i].n=i;
		if(v[i]>0) mv=max(mv,v[i]);
	}
	for(i=0,j=0;i<N;i++) if(v[i]==mv) p[j++]=p[i];
	N=j;
	int cnt = convHULL(N);
	for(i=0;i<cnt;i++)
		flag[m[i].n]=true;
	for(i=0;i<M;i++) 
		if(flag[i]) printf("1");
		else printf("0");
	printf("\n");
}

int main()
{
	int test;
	while(true)
	{
		scanf("%d",&test);
		if(!test) break;
		solve(test);
	}
	return 0;
}

