#pragma comment(linker , "/STACK:128000000")

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
void precalc();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;
	precalc();
	int t = 1;
	//cin >> t;
	while(true) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


#define int li

int mod = 998244353;

int binpow(int q, int w) {
	if (!w)
		return 1;
	if (w & 1)
		return q * binpow(q, w - 1) % mod;
	return binpow(q * q % mod, w / 2);
}

int fact[100500], revfact[100500];

void precalc() {
	fact[0] = revfact[0] = 1;
	for (int i = 1; i < 100500; ++i) {
		fact[i] = fact[i - 1] * i % mod;
		revfact[i] = binpow(fact[i], mod - 2);
	}
}

int getC(int n, int k) {
	return fact[n] * revfact[k] % mod * revfact[n - k] % mod;
}


void solve() {
	int n;
	cin >> n;

	if (n == 0)
		exit(0);

	int rest = 0;

	vector<int> num(12, 0);
	for (int i = 0; i < n; ++i) {
		int cur;
		cin >> cur;
		int cnt = 0;
		bool flag = true;
		while(cur > 1) {
			if (cur & 1) {
				flag = false;
				break;
			}
			++cnt;
			cur /= 2;
		}
		if (flag && cnt <= 11)
			++num[cnt];
		else
			++rest;
	}

	vector<vector<int>> dp(12);
	for (int step = 0; step < 12; ++step)
		dp[step].assign((1 << (11 - step)) + 1, 0);

	{
		int variants = (1 << num[0]);
		for (int i = 0; i < dp[0].size() && i <= num[0]; ++i) {
			dp[0][i] = variants;
			int curC = getC(num[0], i);
			variants -= curC;
			variants %= mod;
		}
	}

	for (int step = 1; step < 12; ++step) {

		for (int have = 0; have <= num[step] && have < dp[step].size(); ++have) {
			int curC = getC(num[step], have);

			for (int got = have; got < dp[step].size(); ++got) {
				int need = (got - have) * 2;
				if (need < dp[step - 1].size()) {
					dp[step][got] += dp[step - 1][need] * curC;
					dp[step][got] %= mod;
				}
			}
		}

		if (num[step] >= dp[step].size()) {
			int variants = (1 << num[step]);
			for (int i = 0; i < dp[step].size(); ++i) {
				int curC = getC(num[step], i);
				variants -= curC;
				variants %= mod;
			}
			dp[step].back() += variants * dp[step - 1][0];
			dp[step].back() %= mod;
		}

	}

	int ans = (dp[11][1] + mod) % mod;

	ans = ans * binpow(2, rest) % mod;

	cout << ans << "\n";

}