#pragma comment(linker , "/STACK:128000000")

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	//cout.sync_with_stdio(0);
	//cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(true) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int n, m;
vector<vector<int>> matrix;

int dx[] = {0, 0, 1, -1};
int dy[] = {1, -1, 0, 0};

bool correct(int x, int y) {
	return x >= 0 && y >= 0 && x < n && y < m;
}

struct State {
	int x, y;
	int mask1, mask2;
	State(int X, int Y, int mask1, int mask2):x(X), y(Y), mask1(mask1), mask2(mask2) {
		if (x == n) {
			x = 0;
			++y;
		}
	}

	void go();
};

int dp[11][2][1 << 10][1 << 10];

inline void setValue(const State& cur, int val) {
	dp[cur.x][cur.y & 1][cur.mask1][cur.mask2] = min(dp[cur.x][cur.y & 1][cur.mask1][cur.mask2], val);
}

inline int getValue(const State& cur) {
	return dp[cur.x][cur.y & 1][cur.mask1][cur.mask2];
}

int getCell(int x, int y) {
	if (!correct(x, y))
		return 0;
	return matrix[x][y];
}

void State::go() {

	if (getValue(*this) > 2 * n * m)
		return;

	//cout << x << ' ' << y << "\n";

	if (!(mask1 & 1)) {
		State nex(x + 1, y, (mask1 >> 1) + (1 << (n - 1)) * (mask2 & 1), (mask2 >> 1) + (getCell(x, y + 1)) * (1 << (n - 1)));
		setValue(nex, getValue(*this));

		nex = State(x + 1, y, (mask1 >> 1) + (1 << (n - 1)) * (!(mask2 & 1)), (mask2 >> 1) + getCell(x, y + 1) * (1 << (n - 1)));
		setValue(nex, getValue(*this) + 2);

		return;
	}

	
	State nex(x + 1, y, (mask1 >> 1) + (1 << (n - 1)) * (mask2 & 1), (mask2 >> 1) + (!getCell(x, y + 1)) * (1 << (n - 1)));

	if (x > 0)
		nex.mask1 ^= (1 << (n - 2));
	if (x < n - 1)
		nex.mask2 ^= 1;
	
	setValue(nex, getValue(*this) + 1);


	nex = State(x + 1, y, (mask1 >> 1) + (1 << (n - 1)) * (!(mask2 & 1)), (mask2 >> 1) + (!getCell(x, y + 1)) * (1 << (n - 1)));

	if (x > 0)
		nex.mask1 ^= (1 << (n - 2));
	if (x < n - 1)
		nex.mask2 ^= 1;
	
	setValue(nex, getValue(*this) + 1);
}

void solve() {
	scanf("%d%d", &n, &m);
	if (!n)
		exit(0);

	matrix.assign(n, vi(m));
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			scanf("%1d", &matrix[i][j]);

	if ((n > m && m > 1) || n == 1) {
		vector<vector<int>> aaa(m, vi(n));
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				aaa[j][i] = matrix[i][j];
		swap(n, m);
		matrix.swap(aaa);
	}

	if (n == 1 && m == 1) {
		cout << matrix[0][0] << "\n";
		return;
	}

	for (int i = 0; i <= n; ++i)
		for (int j = 0; j <= m; ++j)
			for (int mask1 = 0; mask1 < (1 << n); ++mask1)
				for (int mask2 = 0; mask2 < (1 << n); ++mask2)
					dp[i][j & 1][mask1][mask2] = 2 * n * m + 5;

	int startMask = 0;
	for (int i = 0; i < n; ++i)
		if (matrix[i][0])
			startMask |= (1 << i);

	for (int mask1 = 0; mask1 < (1 << n); ++mask1) {
		State cur(0, 0, mask1, startMask);	
		setValue(cur, 0);
	}

	for (int j = 0; j < m; ++j) {

		for (int i = 0; i < n; ++i)
			for (int mask1 = 0; mask1 < (1 << n); ++mask1)
				for (int mask2 = 0; mask2 < (1 << n); ++mask2)
					dp[i][!(j & 1)][mask1][mask2] = 2 * n * m + 5;

		for (int i = 0; i < n; ++i)
			for (int mask1 = 0; mask1 < (1 << n); ++mask1)
				for (int mask2 = 0; mask2 < (1 << n); ++mask2)
					State(i, j, mask1, mask2).go();
	}

	int ans = 2 * n * m + 5;

	for (int mask2 = 0; mask2 < (1 << n); ++mask2)
		ans = min(ans, getValue(State(0, m, 0, mask2)));

	cout << ans << "\n";

}