#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>

using namespace std;

const int MAX_N = 505;
const int INF = 1000000000;

int n, m, x[MAX_N], y[MAX_N], v[MAX_N], d[MAX_N], hull[MAX_N], ans[MAX_N];
double ang[MAX_N];

int ccw(int a, int b, int c) {
    int x1 = x[a] - x[b], y1 = y[a] - y[b], x2 = x[c] - x[b], y2 = y[c] - y[b];

    return y1 * x2 - x1 * y2;
}

bool cmp(int a, int b) {
    int ang = ccw(a, m, b);

    if (ang > 0) {
        return false;
    }

    if (ang < 0) {
        return true;
    }

    return (x[a] - x[m]) * (x[a] - x[m]) + (y[a] - y[m]) * (y[a] - y[m]) <
           (x[b] - x[m]) * (x[b] - x[m]) + (y[b] - y[m]) * (y[b] - y[m]);
}

int main() {
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    /*
    freopen("task.in", "r", stdin);
    freopen("task.out", "w", stdout);
    */

    while (cin >> n) {
        if (n == 0) {
            break;
        }

        int mx_v = 0;
        for (int i = 0; i < n; i++) {
            cin >> x[i] >> y[i] >> v[i];

            mx_v = max(mx_v, v[i]);
        }

        memset(ans, 0, sizeof(ans));

        int _n = 0;
        for (int i = 0; i < n; i++) {
            bool good = true;

            for (int j = 0; j < n; j++) {
                if (i != j && x[i] == x[j] && y[i] == y[j] && v[i] == v[j]) {
                    good = false;
                    break;
                }
            }

            if (!good) {
                ans[i]--;
            }

            if (v[i] == mx_v) {
                d[_n++] = i;
            }
        }

        if (mx_v == 0) {
            cout << string(n, '0') << endl;
            continue;
        }

        m = d[0];
        for (int i = 0; i < _n; i++) {
            if (y[d[i]] < y[m] || (y[d[i]] == y[m] && x[d[i]] < x[m])) {
                m = d[i];
            }
        }

        sort(d, d + _n, cmp);

        int sz = 0;

        for (int i = 0; i < _n; i++) {
            while (sz > 1 && ccw(hull[sz - 2], hull[sz - 1], d[i]) <= 0) {
                sz--;
            }

            hull[sz++] = d[i];
        }

        while (sz > 2 && ccw(hull[sz - 2], hull[sz - 1], hull[0]) <= 0) {
            sz--;
        }

        if (sz > 1) {
            for (int i = 0; i < _n; i++) {
                if (ans[d[i]] < 0) {
                    continue;
                }

                for (int j = 0; j < sz; j++) {
                    if (ccw(hull[j], d[i], hull[(j + 1) % sz]) == 0) {
                        ans[d[i]] = 1;
                        break;
                    }
                }
            }
        }

        for (int i = 0; i < sz; i++) {
            if (ans[hull[i]] >= 0) {
                ans[hull[i]] = 1;
            }
        }

        for (int i = 0; i < n; i++) {
            cout << max(0, ans[i]);
        }

        cout << endl;
    }

    return 0;
}
