#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second
#define in(n) int (n) = nxt()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int nxt() {
    int res;
    scanf("%d", &res);
    return res;
}


struct pt {
    int x, y;
    pt() {}
    pt(const int &x, const int &y) : x(x), y(y) {}

    pt operator - (const pt &r) const {
        return pt(x - r.x, y - r.y);
    }
    pt operator + (const pt &r) const {
        return pt(x + r.x, y + r.y);
    }

    bool operator < (const pt &r) const {
        return x < r.x || (x == r.x && y < r.y);
    }

    bool operator == (const pt &r) const {
        return x == r.x && y == r.y;
    }
};


int vect(const pt &l, const pt &r) {
    return l.x * r.y - l.y * r.x;
}

int scal(const pt &l, const pt &r) {
    return l.x * r.x + l.y * r.y;
}

pt cmp_pt;
bool cmp(const pt &l, const pt &r) {
    pt l1 = l - cmp_pt;
    pt r1 = r - cmp_pt;
    int ve = vect(l1, r1);
    if (ve != 0) {
        return ve < 0;
    }
    return scal(l1, l1) < scal(r1, r1);
}


void convex(vector<pt> &a) {

    sort(all(a));
    a.resize(unique(all(a)) - a.begin());

    if (a.size() <= 2) {
        return;
    }
    cmp_pt = a[0];
    sort(a.begin() + 1, a.end(), cmp);
    int sz = 1;
    int n = a.size();
    for (int i = 2; i < n; ++i) {
        while (sz > 0 && vect(a[sz] - a[sz - 1], a[i] - a[sz]) > 0) {
            sz--;
        }
        a[++sz] = a[i];
    }
    a.resize(sz + 1);
}

void solve(){
    int n = nxt();
    if (!n) {
        exit(0);
    }

    PII a[n];
    int v[n];
    for (int i = 0; i < n; ++i) {
        a[i].x = nxt();
        a[i].y = nxt();
        v[i] = nxt();
    }
    int id[n];
    for (int i = 0; i < n; ++i) {
        id[i] = i;
    }

    stable_sort(id, id + n, [&](const int &l, const int &r){
         return v[l] > v[r] || (v[l] == v[r] && l < r);
    });

    char ans[n + 1];
    memset(ans, '0', sizeof(ans));
    ans[n] = 0;

    map<PII, vector<int> > ids;
    vector<pt> q;
    q.pb(pt(a[id[0]].x, a[id[0]].y));
    ids[a[id[0]]].pb(id[0]);

    for (int i = 1; i < n; ++i) {
        if (v[id[i]] < v[id[i - 1]]) {
            break;
        }
        ids[a[id[i]]].pb(id[i]);
        q.pb(pt(a[id[i]].x, a[id[i]].y));
    }
    convex(q);
    for (pt r : q) {
        for (int id : ids[mp(r.x, r.y)]) {
            ans[id] = '1';
        }
    }
    puts(ans);
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    while (1) {
        solve();
    }

    return 0;
}
