#include <bits/stdc++.h>
#define int long long
using namespace std;

double x[100007],y[100007];
double x0,y0;

const double eps=1e-9;
const double PII = 3.1415926535;


double  sqr(double x)
{
    return x*x;
}

double get_angle(double x1, double y1, double x2, double y2, double x3, double y3)
{
    double m1 = sqrt(sqr(x2-x1)+sqr(y2-y1));
    double m2 = sqrt(sqr(x3-x2)+sqr(y3-y2));
    double vp = (x2-x1)*(y3-y2) - (x3-x2)*(y2-y1);

    return asin( vp / (m1*m2) );
}

double dist(double x1, double y1, double x2, double y2)
{
    return sqrt( sqr(x1-x2)+sqr(y1-y2) );
}

double R;

char get_cross(double alpha, double x2, double y2, double x3, double y3)
{
    double A1,B1,C1,A2,B2,C2,d,d1,d2,sa,ca;

    sa=sin(alpha);
    ca=cos(alpha);

    A1 = sa; B1=-ca;
    C1 = -x0*sa + y0*ca;

    A2=y3-y2;
    B2 = x2-x3;
    C2=x2*(y2-y3) + y2*(x3-x2);

    d = A1*B2-A2*B1;
    d1 = -C1*B2 + C2*B1;
    d2 = A1*(-C2) + C1*A2;

    if(fabs(d)<eps) {return 0;}

    double xa,ya;
    xa=d1/d; ya=d2/d;

    if( abs(dist(x2,y2,xa,ya) + dist(x3,y3,xa,ya) - dist(x2,y2,x3,y3) ) < eps )
    {
        double x4 = xa-x0;
        double y4 = ya-y0;
        double nrm = sqrt(x4*x4+y4*y4);
        x4/=nrm;
        y4/=nrm;
        if( fabs(x4-ca)>eps || fabs(y4-sa)>eps ) return 0;

        R = dist(x0, y0, xa, ya);
        return 1;
    }


}



main()
{
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);

    int T,n,i;
    cin>>T;

    while(T--)
    {
        cin>>x0>>y0;
        cin>>n;
        double ans=0;
        for(i=0;i<n;i++)cin>>x[i]>>y[i];
        for(i=0;i<n;i++){y[i+n]=y[i];x[i+n]=x[i]; }

        double ang=0;

        for(i=0;i<n;i++)
        {
           ang+=get_angle(x[i],y[i],x[i+1],y[i+1],x[i+2],y[i+2]);
        }

        if(ang<0)
        {
            reverse(x,x+2*n);
            reverse(y,y+2*n);
        }

        double Rb=1e10;
        int ci;

        for(i=0;i<n;i++)
        {
            if(get_cross(0,x[i],y[i],x[i+1],y[i+1]))
            {
              if(R<Rb){ Rb=R;ci=i;}
            }
        }

        double da=0.0001;

        for(double al =0; al<=2*PII; al+=da)
        {
            while(get_cross(al, x[ci],y[ci],x[ci+1],y[ci+1]) == 0) {ci++;}

            ans+=0.5*da*R*R;
        }


        cout<<fixed<<setprecision(6)<<ans<<"\n";

    }

    return 0;
}
