#include <iostream>
#include <cmath>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

typedef long long ll;
int n;
struct v2{
	int x, y, id;
	v2() {}
	v2(const int x, const int y, const int id): x(x), y(y), id(id) {}
	v2(const int x, const int y): x(x), y(y) {}
	v2 operator +(const v2& r) const{
		return v2(x + r.x, y + r.y); }
	v2 operator -(const v2& r) const{
		return v2(x - r.x, y - r.y); }
	double sqlen() const{
		return x * x + y * y; }
	bool operator <(const v2& r) const{
		return x < r.x || x == r.x && y < r.y; }
};
int dot(const v2& l, const v2& r) {
	return l.x * r.x + l.y * r.y;
}
int cross(const v2& l, const v2& r) {
	return l.x * r.y - l.y * r.x;
}

bool good[510];
vector<v2> up, dn;

inline void solve(){
	fill(good, good + n, false);
	int maxv = -1;
	vector<v2> pts;
	for (int i = 0; i < n; ++i){
		int x, y, v;
		cin >> x >> y >> v;
		if (v == maxv){
			pts.push_back(v2(x,y, i));
		} else if (v > maxv){
			pts.resize(0);
			maxv = v;
			pts.push_back(v2(x,y, i));
		}
	}

	
	up.resize(0);
	dn.resize(0);
	sort(pts.begin(), pts.end());
	up.push_back(pts[0]);
	dn.push_back(pts[0]);
	for (int i = 1; i < pts.size(); ++i) {
		v2 x = pts[i];
		int s = cross(pts.back() - pts[0], x - pts[0]);
		while (up.size() > 1 && cross(up.back() - up[up.size() - 2], x - up.back()) >= 0) up.pop_back();
			up.push_back(x);
		while (dn.size() > 1 && cross(dn.back() - dn[dn.size() - 2], x - dn.back()) <= 0) dn.pop_back();
			dn.push_back(x);
	}
	for (int i = 0; i < up.size(); ++i)
		good[up[i].id] = true;
	for (int i = 0; i < dn.size(); ++i)
		good[dn[i].id] = true;
	for (int i = 0; i < n; ++i)
		cout << (good[i]? 1 : 0);
	cout << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	while (cin >> n && n != 0){
		solve();
	}
	return 0;
}