#include <iostream>
#include <cmath>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
ll n;
struct v2{
	ll x, y, id;
	v2() {}
	v2(const ll x, const ll y, const ll id): x(x), y(y), id(id) {}
	v2(const ll x, const ll y): x(x), y(y) {}
	v2 operator +(const v2& r) const{
		return v2(x + r.x, y + r.y); }
	v2 operator -(const v2& r) const{
		return v2(x - r.x, y - r.y); }
	double sqlen() const{
		return x * x + y * y; }
	bool operator <(const v2& r) const{
		return x < r.x || x == r.x && y < r.y; }
};
ll dot(const v2& l, const v2& r) {
	return l.x * r.x + l.y * r.y;
}
ll cross(const v2& l, const v2& r) {
	return l.x * r.y - l.y * r.x;
}

bool good[510];
vector<v2> up, dn;
map<pair<int, int>, int> mm;

inline void solve(){
	fill(good, good + n, false);
	ll maxv = -1;
	vector<v2> pts;
	mm.clear();
	for (ll i = 0; i < n; ++i){
		ll x, y, v;
		cin >> x >> y >> v;
		if (v == maxv){
			if (++mm[make_pair(x, y)] == 1)
				pts.push_back(v2(x,y, i));
		} else if (v > maxv){
			mm.clear();
			pts.resize(0);
			maxv = v;
			pts.push_back(v2(x,y, i));
			mm[make_pair(x, y)]++;
		}
	}

	
	up.resize(0);
	dn.resize(0);
	sort(pts.begin(), pts.end());
	up.push_back(pts[0]);
	dn.push_back(pts[0]);
	for (ll i = 1; i < pts.size(); ++i) {
		v2 x = pts[i];
		while (up.size() > 1 && cross(up.back() - up[up.size() - 2], x - up.back()) > 0) up.pop_back();
			up.push_back(x);
		while (dn.size() > 1 && cross(dn.back() - dn[dn.size() - 2], x - dn.back()) < 0) dn.pop_back();
			dn.push_back(x);
	}
	for (ll i = 0; i < up.size(); ++i) 
		if (mm[make_pair(up[i].x, up[i].y)] == 1)
			good[up[i].id] = true;
	for (ll i = 0; i < dn.size(); ++i)
		if (mm[make_pair(dn[i].x, dn[i].y)] == 1)
			good[dn[i].id] = true;
	for (ll i = 0; i < n; ++i)
		cout << (good[i]? 1 : 0);
	cout << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	while (cin >> n && n != 0){
		solve();
	}
	return 0;
}