#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int N = 1e5;
struct Input {
	int n, m;
	int a[N];
	
	bool read () {
		if (!(scanf("%d%d", &n, &m) == 2 && !(n == 0 && m == 0))) {
			return 0;
		}
		forn (i, n) {
			scanf("%d", &a[i]);
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	vi ans;
	
	void write () {
		forn (i, sz(ans)) {
			printf("%d\n", ans[i]);
		}
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

const int mod = 998244353;

int mPow (int x, int y) {
	ll r = 1, c = x;
	while (y > 0) {
		if (y & 1) {
			(r *= c) %= mod;
		}
		(c *= c) %= mod;
		y >>= 1;
	}
	return r;
}


namespace _fft {

const int L = 19;
const int LL = 23;
const int N = 1 << L;

int st[N];
int rBit[N];

void precalc () {
	int root = 31;
	root =  mPow(root, 1 << (LL - L));

	st[0] = 1;
	for (int i = 1; i < N; ++i) {
		st[i] = (st[i - 1] * ll(root)) % mod;
	}

	memset(rBit, 0, sizeof rBit);
	forn (i, N) {
		forn (j, L) {
			if (i & (1 << j)) {
				rBit[i] |= (1 << (L - j - 1));
			}
		}
	}	
}

ll _a[N], _b[N];

void fft (ll a[], int n) {
	int k = 0;
	while ((1 << k) < n) {
		++k;
	}
	for (int i = 0; i < n; ++i) {
		int j = rBit[i] >> (L - k);
		if (i < j) {
			swap(a[i], a[j]);
		}
	}
	
	for (int k = 0, l = 1; l < n; ++k, l *= 2) {
		for (int i = 0; i < n; i += 2 * l) {
			for (int j = 0; j < l; ++j) {
				ll u = a[i + j], v = (st[j << (L - k - 1)] * a[i + j + l]) % mod;
				a[i + j] = u + v;
				if (a[i + j] >= mod) {
					a[i + j] -= mod;
				}
				a[i + j + l] = u - v + mod;
				if (a[i + j + l] >= mod) {
					a[i + j + l] -= mod;
				}
			}
		}
	}
}

void inv (ll a[], int n) {
	reverse(a + 1, a + n);
	ll e = mPow(n, mod - 2);
	forn (i, n) {
		(a[i] *= e) %= mod;
	}
}

};

vi mul (vi a, vi b) {
	using namespace _fft;
	int k = 0;
	while ((1 << k) < sz(a) + sz(b) - 1) {
		++k;
	}
	
	int n = 1 << k;
	memset(_a, 0, sizeof(ll) * n);
	memset(_b, 0, sizeof(ll) * n);
	forn (i, sz(a)) {
		_a[i] = a[i];
	}
	forn (i, sz(b)) {
		_b[i] = b[i];
	}
	fft(_a, n);
	fft(_b, n);
	forn (i, n) {
		(_a[i] *= _b[i]) %= mod;
	}
	fft(_a, n);
	inv(_a, n);
	vi c(sz(a) + sz(b) - 1);
	forn (i, sz(c)) {
		c[i] = _a[i];
	}
	return c;
}

const int K = 2 * N;
bool isPrime (int x) {
	for (int i = 2; i * i <= x; ++i) {
		if (x % i == 0) {
			return 0;
		}
	}
	return 1;
}

struct Solution: Data {
	static ll _f[K + 1];

	static void precalc () {
		_f[0] = 1;
		_f[1] = 0;
		for (int i = 2; i <= K; ++i) {
			_f[i] = (_f[i - 1] * i  + ((i & 1) ? -1 : 1) + mod) % mod;
		}
	}
	
	static ll f (int n) {
		return _f[n];
	}
	
	vi calcA (int l, int r) {
		// debug(mp(l, r));
		if (r - l == 1) {
			return {a[l], 1};
		}
		int m = (l + r) >> 1;
		return mul(calcA(l, m), calcA(m, r));
	}
	
	void solve () {
		vi A = calcA(0, n);
		reverse(all(A));
		while (sz(A) < n + m) {
			A.pb(0);
		}
		vi F;
		forn (i, n + m) {
			F.pb(f(i));
		}
		vi res = mul(A, F);
		ans = vi(res.begin() + n, res.begin() + n + m);
	}
	
	void clear () {
	}
};

ll Solution::_f[K + 1];
	
	
Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
	_fft::precalc();
	Solution::precalc();
	
#ifdef SG
	freopen("j.in", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		printf("\n");
		sol.clear();
	}

#else
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#endif
	return 0;
}
