#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const short INF = 30000;
const int N = 10;
const int ALL = (1 << N) - 1;
int n, m, ans[2][1 << N][1 << N], a[N + 1][N];
char s[N + 1];

void relax(int& a, int b) {
	if (a > b) a = b;
}

void fill(int t) {
	for (int prerow = 0; prerow < (1 << m); ++prerow)
		for (int currow = 0; currow < (1 << m); ++currow)
			ans[t][prerow][currow] = INF;
}

inline int get_bit(int x, int bit) {
	return (x >> bit) & 1;
}

inline int set_bit(int x, int bit, int value) {
	return (get_bit(x, bit) == value) ? x : (x ^ (1 << bit)); 
	//return (x | (value << bit)) & (ALL ^ ((value ^ 1) << bit));
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	//double start = clock();
	while ((scanf("%d%d", &n, &m) == 2) && (n > 0) && (m > 0)) {
		int total = 0;
		for (int i = 0; i < n; ++i) {
			scanf("%s", s);
			for (int j = 0; j < m; ++j) {
				a[i][j] = (s[j] == '1') ? 1 : 0;
				total += a[i][j];
			}
		}
		int t = 0, best = INF, mask = 0;
		for (int j = 0; j < m; ++j) {
			mask = set_bit(mask, j, a[0][j]);
			a[n][j] = 0;
		}
		fill(t);
		for (int prerow = 0; prerow < (1 << m); ++prerow)
			ans[t][prerow][mask] = 0;
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j, t ^= 1) {
				fill(t ^ 1);
				for (int prerow = 0; prerow < (1 << m); ++prerow) 
					for (int currow = 0; currow < (1 << m); ++currow) {
						if (ans[t][prerow][currow] > 2 * total) continue;
						int cur_bit = get_bit(currow, j);
						// both actions
						// no action!
						int value = set_bit(currow, j, a[i + 1][j]);
						if (!((prerow >> j) & 1)) {
							relax(ans[t ^ 1][prerow | ((cur_bit ^ 1) << j)][value], ans[t][prerow][currow] + 2);
							relax(ans[t ^ 1][prerow | (cur_bit << j)][value], ans[t][prerow][currow]);
						} else {
							//relax(ans[t ^ 1][set_bit(prerow, j, cur_bit ^ 1)][value], ans[t][prerow][currow] + 2);
							int nprerow = prerow, ncurrow = currow;
							if (j > 0) nprerow ^= (1 << (j - 1));
							if (j + 1 < m) ncurrow ^= (1 << (j + 1));
							ncurrow = set_bit(ncurrow, j, a[i + 1][j] ^ 1);
							int nvalue = set_bit(nprerow, j, cur_bit);
							// me excluded
							relax(ans[t ^ 1][nvalue][ncurrow], ans[t][prerow][currow] + 1);
							//me included
							relax(ans[t ^ 1][nvalue ^ (1 << j)][ncurrow], ans[t][prerow][currow] + 1);
						}
					}
			}
		for (int i = 0; i < n; ++i)
			for (int currow = 0; currow < (1 << m); ++currow)
				relax(best, ans[t][0][currow]);
		printf("%d\n", (int) best);
	}
	//eprintf("%.2lf\n", (clock() - start) / CLOCKS_PER_SEC);
	return 0;
}