#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const short INF = 30000;
const int N = 10;
const int ALL = (1 << N) - 1;
int n, m, ans[2][1 << N][1 << N], a[N + 1][N], b[N + 1][N];
char s[N + 1];

void relax(int& a, int b) {
	if (a > b) a = b;
}

void fill(int t) {
	for (int prerow = 0; prerow < (1 << m); ++prerow)
		for (int currow = 0; currow < (1 << m); ++currow)
			ans[t][prerow][currow] = INF;
}

inline int get_bit(int x, int bit) {
	return (x >> bit) & 1;
}

inline int set_bit(int x, int bit, int value) {
	return (get_bit(x, bit) == value) ? x : (x ^ (1 << bit)); 
	//return (x | (value << bit)) & (ALL ^ ((value ^ 1) << bit));
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	double start = clock();
	while ((scanf("%d%d", &n, &m) == 2) && (n > 0) && (m > 0)) {
		for (int i = 0; i < n; ++i) {
			scanf("%s", s);
			for (int j = 0; j < m; ++j)
				a[i][j] = (s[j] == '1') ? 1 : 0;
		}
		if (n < m) {
			for (int i = 0; i < n; ++i)
				for (int j = 0; j < m; ++j)
					b[j][i] = a[i][j];
			swap(n, m);
			for (int i = 0; i < n; ++i)
				for (int j = 0; j < m; ++j)
					a[i][j] = b[i][j];
		}
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				b[i][j] = a[i][j];
		int t = 0, best = INF, mask = 0, total = 0;
		const int dx[4] = {-1, 1, 0, 0};
		const int dy[4] = {0, 0, 1, -1};
		while (true) {
			bool good = false;
			for (int i = 0; i < n; ++i)
				for (int j = 0; j < m; ++j) {
					int done = 0;
					for (int dir = 0; dir < 4; ++dir)
						if ((i + dx[dir] >= 0) && (i + dx[dir] < n) && (j + dy[dir] >= 0) && (j + dy[dir] < m))
							done += b[i + dx[dir]][j + dy[dir]];
					if (done > 2) {
						good = true;
						total++;
						for (int dir = 0; dir < 4; ++dir)
							if ((i + dx[dir] >= 0) && (i + dx[dir] < n) && (j + dy[dir] >= 0) && (j + dy[dir] < m))
								b[i + dx[dir]][j + dy[dir]] ^= 1;	
					}
					done = b[i][j];
					for (int dir = 0; dir < 4; ++dir)
						if ((i + dx[dir] >= 0) && (i + dx[dir] < n) && (j + dy[dir] >= 0) && (j + dy[dir] < m))
							done += b[i + dx[dir]][j + dy[dir]];
					if (done > 2) {
						good = true;
						total++;
						b[i][j] ^= 1;
						for (int dir = 0; dir < 4; ++dir)
							if ((i + dx[dir] >= 0) && (i + dx[dir] < n) && (j + dy[dir] >= 0) && (j + dy[dir] < m))
								b[i + dx[dir]][j + dy[dir]] ^= 1;	
					}
				}
			if (!good) break;
		}
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				total += 2 * b[i][j];
		for (int j = 0; j < m; ++j) {
			mask = set_bit(mask, j, a[0][j]);
			a[n][j] = 0;
		}
		fill(t);
		best = total;
		for (int prerow = 0; prerow < (1 << m); ++prerow)
			ans[t][prerow][mask] = 0;
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j, t ^= 1) {
				fill(t ^ 1);
				int curmin = total - 7;
				for (int prerow = 0; prerow < (1 << m); ++prerow) 
					for (int currow = 0; currow < (1 << m); ++currow) {
						if (ans[t][prerow][currow] >= curmin + 7) continue;
						if (ans[t][prerow][currow] < curmin)
							curmin = ans[t][prerow][currow];
						int cur_bit = get_bit(currow, j);
						int value = set_bit(currow, j, a[i + 1][j]);
						if (!((prerow >> j) & 1)) {
							relax(ans[t ^ 1][prerow | ((cur_bit ^ 1) << j)][value], ans[t][prerow][currow] + 2);
							relax(ans[t ^ 1][prerow | (cur_bit << j)][value], ans[t][prerow][currow]);
						} else {
							int nprerow = prerow, ncurrow = currow;
							if (j > 0) nprerow ^= (1 << (j - 1));
							if (j + 1 < m) ncurrow ^= (1 << (j + 1));
							ncurrow = set_bit(ncurrow, j, a[i + 1][j] ^ 1);
							int nvalue = set_bit(nprerow, j, cur_bit);
							relax(ans[t ^ 1][nvalue][ncurrow], ans[t][prerow][currow] + 1);
							relax(ans[t ^ 1][nvalue ^ (1 << j)][ncurrow], ans[t][prerow][currow] + 1);
						}
					}
			}
		for (int i = 0; i < n; ++i)
			for (int currow = 0; currow < (1 << m); ++currow)
				relax(best, ans[t][0][currow]);
		printf("%d\n", (int) best);
	}
	//eprintf("%.2lf\n", (clock() - start) / CLOCKS_PER_SEC);
	return 0;
}