#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int M = 998244353;
const int g = 3;
const int invg = 332748118;
const int N = (int) 1 << 19;
int tmp1[N], tmp2[N], a[N], rev[N], n, m;

int mult(int a, int b) {
	return (a * (int64) b) % M;
}

int pow(int a, int b) {
	if (b == 0) return 1;
	if (b & 1) return mult(pow(a, b - 1), a);
	int tmp = pow(a, b / 2);
	return mult(tmp, tmp);
}

int inverse(int x) {
	return pow(x, M - 2);
}

int get_bit_rev(int x, int k) {
	int y = 0;
	for (int i = 0; i < k; ++i)
		if ((x >> i) & 1) y |= (1 << (k - i - 1));
	return y;
}

int sum(int a, int b) {
	if ((a += b) >= M) a -= M;
	return a;
}

void fft(int * a, int k, bool inverse) {
	int n = (1 << k);
	for (int i = 0; i < n; ++i) {
		int j = rev[i];
		if (j < i) swap(a[i], a[j]);
	}
	for (int l = 1; l < n; l *= 2) {
		int wn = pow(inverse ? invg : g, (M - 1) / (2 * l));
		for (int i = 0; i < n; i += 2 * l) {
			int w = 1;
			for (int j = 0; j < l; ++j) {
				int u = a[i + j], v = mult(w, a[i + j + l]);
				a[i + j] = sum(u, v), a[i + j + l] = sum(u, M - v);
				w = mult(w, wn);
			}
		}
	}
	if (inverse) {
		int coef = ::inverse(n);
		for (int i = 0; i < n; ++i)
			a[i] = mult(a[i], coef);
	}
}

struct tpoly {
	int *coef, n;
	tpoly(int x) {
		coef = new int[2];
		coef[0] = x, coef[1] = 1, n = 2;
	}
	tpoly(int * data, int size) {
		coef = new int[size], n = size;
		memcpy(coef, data, size * sizeof(int));
		while ((n > 0) && (coef[n - 1] == 0)) --n;
	}
} f(0);

tpoly operator*(const tpoly& a, const tpoly& b) {
	int k = 0;
	while ((1 << k) < a.n + b.n) ++k;
	int n = 1 << k;
	for (int i = 0; i < n; ++i) {
		rev[i] = get_bit_rev(i, k);
		tmp1[i] = (i < a.n) ? a.coef[i] : 0;
		tmp2[i] = (i < b.n) ? b.coef[i] : 0;
	}
	fft(tmp1, k, false);
	fft(tmp2, k, false);
	for (int i = 0; i < n; ++i)
		tmp1[i] = mult(tmp1[i], tmp2[i]);
	fft(tmp1, k, true);
	return tpoly(tmp1, a.n + b.n);
}

tpoly solve(int l, int r) {
	if (l == r - 1) return tpoly(a[l]);
	int m = (l + r) / 2;
	return solve(l, m) * solve(m, r);
}

int main() {
	/*assert(freopen("input.txt", "w", stdout));
	for (int it = 0; it < 6; ++it) {
		int n = (int) 1e5, m = (int) 1e5;
		printf("%d %d\n", n, m);
		for (int i = 0; i < n; ++i)
			printf("%d ", rand());
		printf("\n");
	}
	return 0;*/
	//double start = clock();
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	f.coef = new int[N];
	f.coef[0] = 1;
	for (int i = 1, sign = -1; i < (int) 2e5 + 10; ++i, sign *= -1)
		f.coef[i] = sum(sign, mult(i, f.coef[i - 1]));
	while ((scanf("%d%d", &n, &m) == 2) && (n > 0) && (m > 0)) {
		for (int i = 0; i < n; ++i)
			scanf("%d", &a[i]);
		tpoly C = solve(0, n);
		f.n = n + m;
		reverse(f.coef, f.coef + n + m);
		tpoly T = f * C;
		for (int i = n + m - 1; i >= n; --i)
			printf("%d\n", T.coef[i]);
		reverse(f.coef, f.coef + n + m);
		//eprintf("%.2lf\n", (clock() - start) / CLOCKS_PER_SEC);
	}
	return 0;
}
