#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int maxn = 510; 
const int inf = 1000000000; 


int n; 
pii r[4 * maxn]; 
char a[maxn][maxn];
int sz; 
int degout[maxn]; 
bool used[maxn]; 

void input() {
	scanf("%d", &n);
	if (!n) exit(0); 
	for (int i = 0; i < n; i++) {
		gets(a[i]); 
		for (int j = 0; j < n; j++) {
			a[i][j] -= '0'; 
		}
	}
}

void add(int v, int val) {
	v += sz; 
	r[v] = mp(val, v - sz); 
	while (v > 1) {
		v /= 2; 
		r[v] = max(r[v * 2], r[v * 2 + 1]);
	}
}

pii getmin(int l, int rr) {
	pii res = mp(-inf, -inf); 
	l += sz, rr += sz; 
	while (l <= rr) {
		res = max(res, r[l]); 
		res = max(res, r[rr]); 
		l = (l + 1) / 2; 
		rr = (rr - 1) / 2; 
	}
	return res; 
}

void solution() {
	memset(degout, 0, sizeof(degout)); 
	memset(used, 0, sizeof(used)); 
	sz = 1; 
	while (sz < n) sz *= 2; 

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (a[i][j]) degout[i]++; 
		}
		add(i, degout[i]); 
	}
	
	vector<int> ans;
	for (int i = 0; i < n; i++) {
		pii cur = getmin(0, n - 1); 
		int v = cur.second; 
		for (int j = 0; j < n; j++) { 
			if (used[j]) continue; 
			if (a[j][v]) degout[j]--; 
			add(j, degout[j]); 
		}
		ans.pb(v); 
		used[v] = 1; 
		add(v, -inf); 
	}

	for (int i = 0; i < ans.size(); i++) {
		printf("%d ", ans[i] + 1); 
	}
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 

	while (1) {
		input(); 
		solution(); 
	}

	return 0;
}