#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int MOD = 998244353;

int cnt[3000], d[3000];
ll nd[3000];
int pw[100100], f[100100], rf[100100], a[100100], b[100100];

inline int calc(int a, int b) {
	int res = 1;
	while (b > 0) {
		if (b % 2 != 0) {
			res = (1LL * res * a) % MOD;
		}
		a = (1LL * a * a) % MOD;
		b /= 2;
	}
	return res;
}

const int POW = (1 << 23);
const int P = calc(3, 17 * 7);
const int RP = calc(P, MOD - 2);

inline void init() {
	pw[0] = f[0] = 1;
	for (int i = 1; i < 100100; ++i) {
		pw[i] = (2LL * pw[i - 1]) % MOD;
		f[i] = (1LL * f[i - 1] * i) % MOD;
	}
	for (int i = 0; i < 100100; ++i) {
		rf[i] = calc(f[i], MOD - 2);
	}
}

inline int cnk(int n, int k) {
	if (k == 0 || k == n) {
		return 1;
	}
	if (k > n || k < 0) {
		return 0;
	}
	int res = (1LL * f[n] * rf[k]) % MOD;
	res = (1LL * res * rf[n - k]) % MOD;
	return res;
}

inline void fft(int *a, int n, bool fl) {
	for (int i = 1, j = 0; i < n; ++i) {
		int bit = n / 2;
		for (; j >= bit; bit /= 2) {
			j -= bit;
		}
		j += bit;
		if (i < j) {
			swap(a[i], a[j]);
		}
	}
	for (int len = 2; len <= n; len *= 2) {
		int wlen = (fl ? RP : P);
		for (int i = len; i < POW; i *= 2) {
			wlen = (1LL * wlen * wlen) % MOD;
		}
		for (int i = 0; i < n; i += len) {
			int w = 1;
			for (int j = 0; j < len / 2; ++j) {
				int u = a[i + j], v = (1LL * a[i + j + len / 2] * w) % MOD;
				a[i + j] = (u + v) % MOD;
				a[i + j + len / 2] = (u - v + MOD) % MOD;
				w = (1LL * w * wlen) % MOD;
			}
		}
	}
	if (fl) {
		int rev = calc(n, MOD - 2);
		for (int i = 0; i < n; ++i) {
			a[i] = (1LL * a[i] * rev) % MOD;
		}
	}
}

inline bool solve() {
	int n;
	scanf("%d", &n);
	if (n == 0) {
		return false;
	}
	for (int i = 1; i <= 2048; ++i) {
		cnt[i] = 0;
	}
	int bad = 0;
	for (int i = 0; i < n; ++i) {
		int cur;
		scanf("%d", &cur);
		if (cur > 0 && (cur & (cur - 1)) == 0) {
			++cnt[cur];
		} else {
			++bad;
		}
	}
	for (int i = 0; i <= 2048; ++i) {
		d[i] = 0;
	}
	d[0] = 1;
	int maxv = 1;
	while (maxv < 2049) {
		maxv *= 2;
	}
	maxv *= 2;
	for (int i = 1; i <= 2048; ++i) {
		if (cnt[i] == 0) {
			continue;
		}
		for (int j = 0; j < maxv; ++j) {
			a[j] = b[j] = 0;
		}
		for (int j = 0; j <= 2048; ++j) {
			a[j] = d[j];
		}
		for (int j = 0; j <= cnt[i]; ++j) {
			int z = min(j * i, 2048);
			b[z] += cnk(cnt[i], j);
			if (b[z] >= MOD) {
				b[z] -= MOD;
			}
		}
		fft(a, maxv, false);
		fft(b, maxv, false);
		for (int j = 0; j < maxv; ++j) {
			a[j] = (1LL * a[j] * b[j]) % MOD;
		}
		fft(a, maxv, true);
		for (int j = 0; j <= 2048; ++j) {
			d[j] = 0;
		}
		for (int j = 0; j < maxv; ++j) {
			int z = min(j, 2048);
			d[z] += a[j];
			if (d[z] >= MOD) {
				d[z] -= MOD;
			}
		}
	}
	int ans = (1LL * d[2048] * pw[bad]) % MOD;
	printf("%d\n", ans);
	return true;
}

inline void gen() {
	freopen("A.in", "w", stdout);
	for (int i = 0; i < 70; ++i) {
		int n = int(1e5);
		cout << n << endl;
		for (int j = 0; j < n; ++j) {
			cout << 1 << " ";//(1 << (rand() % 12)) << " ";
		}
		cout << endl;
	}
	cout << 0 << endl;
	exit(0);
}

inline void fact(int n) {
	for (int i = 2; i * i <= n; ++i) {
		if (n % i == 0) {
			int cnt = 0;
			while (n % i == 0) {
				++cnt;
				n /= i;
			}
			cerr << i << " " << cnt << endl;
		}
	}
	if (n > 1) {
		cerr << n << " " << 1 << endl;
	}
	cerr << "OK" << endl;
}

int main() {
	//gen();
#ifdef LOCAL42
#define TASK "A"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	//fact(MOD - 1);
	init();
	while (solve());
	cerr << 1.0 * clock() / CLOCKS_PER_SEC << endl;
	return 0;
}
