#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 555;

struct point {

	int x, y, v, num;

	point() {}

	point(int x, int y) {
		this->x = x;
		this->y = y;
	}

};

point operator + (const point &a, const point &b) {
	return point(a.x + b.x, a.y + b.y);
}

point operator - (const point &a, const point &b) {
	return point(a.x - b.x, a.y - b.y);
}

bool operator < (const point &a, const point &b) {
	return mp(a.x, a.y) < mp(b.x, b.y);
}

bool operator == (const point &a, const point &b) {
	return mp(a.x, a.y) == mp(b.x, b.y);
}

bool good[N];
point p[N], q[N];
int st[N];

inline int vec(const point &a, const point &b) {
	return a.x * b.y - b.x * a.y;
}

inline int sqr(int x) {
	return x * x;
}

inline int len2(const point &v) {
	return sqr(v.x) + sqr(v.y);
}

inline bool cmp(const point &a, const point &b) {
	int v = vec(a, b);
	if (v != 0) {
		return v > 0;
	}
	return len2(a) < len2(b);
}

struct line {

	int a, b, c;

	line(point &A, point &B) {
		a = A.y - B.y;
		b = B.x - A.x;
		c = -a * A.x - b * A.y;
	}

};

inline int dist(line &l, point &p) {
	return l.a * p.x + l.b * p.y + l.c;
}

inline bool inside(point &a, point &b, point &c) {
	int min_x = a.x, max_x = b.x;
	if (min_x > max_x) {
		swap(min_x, max_x);
	}
	int min_y = a.y, max_y = b.y;
	if (min_y > max_y) {
		swap(min_y, max_y);
	}
	return min_x <= c.x && c.x <= max_x && min_y <= c.y && c.y <= max_y;
}

inline bool bad(point &a, point &b, point &c) {
	point v1 = b - a, v2 = c - a;
	int v = vec(v1, v2);
	if (v != 0) {
		return v < 0;
	}
	return len2(v1) <= len2(v2);
}

inline bool solve() {
	int n;
	scanf("%d", &n);
	if (n == 0) {
		return false;
	}
	int max_v = -inf;
	for (int i = 0; i < n; ++i) {
		scanf("%d %d %d", &p[i].x, &p[i].y, &p[i].v);
		p[i].num = i;
		good[i] = true;
		q[i] = p[i];
		max_v = max(max_v, p[i].v);
	}
	if (max_v == 0) {
		max_v = -inf;
	}
	for (int i = 0; i < n - 1; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (p[i].v == max_v && p[j].v == max_v && p[i] == p[j]) {
				good[i] = good[j] = false;
			}
		}
	}
	int sz = 0;
	for (int i = 0; i < n; ++i) {
		if (p[i].v == max_v) {
			p[sz++] = p[i];
		}
	}
	sort(p, p + sz);
	sz = unique(p, p + sz) - p;
	for (int i = 1; i < sz; ++i) {
		p[i] = p[i] - p[0];
	}
	if (sz >= 2) {
		sort(p + 1, p + sz, cmp);
	}
	for (int i = 1; i < sz; ++i) {
		p[i] = p[i] + p[0];
	}
	int k = 0;
	for (int i = 0; i < sz; ++i) {
		while (k >= 2 && bad(p[st[k - 2]], p[st[k - 1]], p[i])) {
			--k;
		}
		st[k++] = i;
	}
	for (int i = 0; i < n; ++i) {
		bool fl = false;
		for (int j = 0; j < k; ++j) {
			line l(p[st[j]], p[st[(j + 1) % k]]);
			if (dist(l, q[i]) == 0 && inside(p[st[j]], p[st[(j + 1) % k]], q[i])) {
				fl = true;
				break;
			}
		}
		if (good[i] && !fl) {
			good[i] = false;
		}
		if (q[i].v != max_v) {
			good[i] = false;
		}
		printf("%d", (good[i] ? 1 : 0));
	}
	puts("");
	return true;
}

int main() {
#ifdef LOCAL42
#define TASK "B"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	while (solve());
	return 0;
}
