#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int MOD = 998244353;

inline int calc(int a, int b) {
	int res = 1;
	while (b > 0) {
		if (b % 2 != 0) {
			res = (1LL * res * a) % MOD;
		}
		a = (1LL * a * a) % MOD;
		b /= 2;
	}
	return res;
}

const int POW = (1 << 23);
const int P = calc(3, 17 * 7);
const int RP = calc(P, MOD - 2);

int _wlen[(1 << 20)][2];

inline void init() {
	for (int i = 2; i <= (1 << 19); i *= 2) {
		for (int j = 0; j < 2; ++j) {
			int wlen = (j ? RP : P);
			for (int z = i; z < POW; z *= 2) {
				wlen = (1LL * wlen * wlen) % MOD;
			}
			_wlen[i][j] = wlen;
		}
	}
}

inline void fft(int *a, int n, bool fl) {
	for (int i = 1, j = 0; i < n; ++i) {
		int bit = n / 2;
		for (; j >= bit; bit /= 2) {
			j -= bit;
		}
		j += bit;
		if (i < j) {
			swap(a[i], a[j]);
		}
	}
	for (int len = 2; len <= n; len *= 2) {
		int wlen = _wlen[len][fl];
		for (int i = 0; i < n; i += len) {
			int w = 1;
			for (int j = 0; j < len / 2; ++j) {
				int u = a[i + j], v = (1LL * a[i + j + len / 2] * w) % MOD;
				a[i + j] = u + v;
				if (a[i + j] >= MOD) {
					a[i + j] -= MOD;
				}
				a[i + j + len / 2] = u - v;
				if (a[i + j + len / 2] < 0) {
					a[i + j + len / 2] += MOD;
				}
				w = (1LL * w * wlen) % MOD;
			}
		}
	}
	if (fl) {
		int rev = calc(n, MOD - 2);
		for (int i = 0; i < n; ++i) {
			a[i] = (1LL * a[i] * rev) % MOD;
		}
	}
}

const int N = (1 << 19);
const int LOG = 19;

struct tans {

	int sz;
	int a[N];

};

tans ca[LOG], cb[LOG];
int a[N], b[2 * N], s[2 * N];

void calc(int l, int r, int deep, tans &ans) {
	if (l == r) {
		ans.sz = 2;
		ans.a[0] = a[l];
		ans.a[1] = 1;
		return;
	}
	assert(deep + 1 < LOG);
	int mid = (l + r) / 2;
	calc(l, mid, deep + 1, ca[deep + 1]);
	calc(mid + 1, r, deep + 1, cb[deep + 1]);
	int maxv = 1;
	while (maxv < max(ca[deep + 1].sz, cb[deep + 1].sz)) {
		maxv *= 2;
	}
	maxv *= 2;
	for (int i = ca[deep + 1].sz; i < maxv; ++i) {
		ca[deep + 1].a[i] = 0;
	}
	for (int i = cb[deep + 1].sz; i < maxv; ++i) {
		cb[deep + 1].a[i] = 0;
	}
	fft(ca[deep + 1].a, maxv, false);
	fft(cb[deep + 1].a, maxv, false);
	for (int i = 0; i < maxv; ++i) {
		ca[deep + 1].a[i] = (1LL * ca[deep + 1].a[i] * cb[deep + 1].a[i]) % MOD;
	}
	fft(ca[deep + 1].a, maxv, true);
	ans.sz = maxv;
	for (int i = 0; i < maxv; ++i) {
		ans.a[i] = ca[deep + 1].a[i];
	}
	while (ans.sz > 1 && ans.a[ans.sz - 1] == 0) {
		--ans.sz;
	}
}

inline bool solve() {
	int n, m;
	scanf("%d %d", &n, &m);
	if (n == 0 && m == 0) {
		return false;
	}
	for (int i = 0; i < n; ++i) {
		scanf("%d", &a[i]);
	}
	calc(0, n - 1, 0, ca[0]);
	assert(ca[0].sz <= n + 1);
	for (int i = 0; i < n + 1; ++i) {
		s[i] = (i < ca[0].sz ? ca[0].a[i] : 0);
	}
	reverse(s, s + n + 1);
	for (int i = n + 1; i < n + m; ++i) {
		s[i] = 0;
	}
	b[0] = 1;
	for (int i = 1; i < n + m; ++i) {
		b[i] = (1LL * b[i - 1] * i + (i % 2 == 0 ? 1 : -1) + MOD) % MOD;
	}
	int maxv = 1;
	while (maxv < n + m) {
		maxv *= 2;
	}
	maxv *= 2;
	for (int i = maxv; i < n + m; ++i) {
		s[i] = b[i] = 0;
	}
	fft(s, maxv, false);
	fft(b, maxv, false);
	for (int i = 0; i < maxv; ++i) {
		s[i] = (1LL * s[i] * b[i]) % MOD;
	}
	fft(s, maxv, true);
	for (int i = 0; i < m; ++i) {
		printf("%d\n", s[n + i]);
	}
	return true;
}

inline void gen() {
	freopen("J2.in", "w", stdout);
	for (int i = 0; i < 5; ++i) {
		cout << int(1e5) << " " << int(1e5) << endl;
		for (int j = 0; j < int(1e5); ++j) {
			cout << "1 ";
		}
		cout << endl;
	}
	cout << "0 0" << endl;
	exit(0);
}

int main() {
	//gen();
#ifdef LOCAL42
#define TASK "J"
	freopen(TASK "2.in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	init();
	while (solve());
	cerr << 1.0 * clock() / CLOCKS_PER_SEC << endl;
	return 0;
}
