#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

const int N = 400500;

struct vt
{
	double x, y;
	vt(double _x, double _y)
	{
		x = _x, y = _y;
	}
	friend vt operator +(vt a, vt b)
	{
		return vt(a.x + b.x, a.y + b.y);
	}
	friend vt operator -(vt a, vt b)
	{
		return vt(a.x - b.x, a.y - b.y);
	}
	friend double operator *(vt a, vt b)
	{
		return a.x * b.x + a.y * b.y;		
	}
	friend double operator ^(vt a, vt b)
	{
		return a.x * b.y - b.x * a.y;
	}
	friend vt operator *(vt a,  double k)
	{
		return vt(a.x * k, a.y * k);
	}
	friend vt operator /(vt a, double k)
	{
		return vt(a.x / k, a.y / k);
	}
	double abs()
	{
		return sqrt(x * x + y * y);
	}
	vt norm()
	{
		return (*this) / abs();
	}
	friend bool operator <(vt a, vt b)
	{
		return (a ^ b) > eps;
	}
	double ang()
	{
		return atan2(y, x);
	}
	vt(){}
};

vt P[N];

int spt = 0;
vt A[N], B[N];
bool up[N];


vt inter(vt a, vt b, vt c, vt d)
{
	assert(fabs((b - a) ^ (c - d)) > eps);
	return (a * ((b - c) ^ (d - c)) + b * ((d - c) ^ (a - c))) / ((b - a) ^ (d - c));
}


struct cmp
{
	vt* ray;
	cmp(vt* _ray) : ray(_ray) {}
	bool operator ()(int a, int b)
	{
		vt va = inter(A[a], B[a], vt(0, 0), *ray);
		vt vb = inter(A[b], B[b], vt(0, 0), *ray);
		double da = va * *ray, db = vb * *ray;
		if (fabs(da - db) < eps)
			return a < b;
		else
			return da < db;
	}
};

bool ev_cmp(pair<vt, int> a, pair<vt, int> b)
{
	int ua = a.second, ub = b.second;
	if (ua < 0) ua = ~ua;
	if (ub < 0) ub = ~ub;
	if (up[ua] != up[ub])
		return up[ua] > up[ub];
	else
	{
		double qa = a.first.ang();
		double qb = b.first.ang();
			
		if (up[ua])
		{
			if (qa < 0)
				qa += 2 * pi;
			if (qb < 0)
				qb += 2 * pi;
		}
		else
		{
			if (qa > 0)
				qa -= 2 * pi;
			if (qb > 0)
				qb -= 2 * pi;
		}
		if (fabs(qa - qb) < eps)
			return false;
		return qa < qb;
	}
	
}

int ept = 0;
pair<vt, int> E[N];

void add(vt a, vt b)
{
	if (b < a)
		swap(a, b);
	A[spt] = a;
	B[spt] = b;
	up[spt] = (a + b).y > 0;
	E[ept++] = make_pair(a, spt);
	E[ept++] = make_pair(b, ~spt);
	spt++;
}

void solve()
{
	int n;
	ept = spt = 0;
	vt O;
	scanf("%lf %lf", &O.x, &O.y);
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%lf %lf", &P[i].x, &P[i].y), P[i] = P[i] - O;
	O = vt(0, 0);
	for (int i = 0; i < n; i++)
	{
		vt a = P[i], b = P[(i + 1) >= n ? 0 : i + 1];
		if (fabs(a ^ b) < eps)
			continue;
		if (a.y > b.y)
			swap(a, b);
		if (a.y < -eps && b.y > eps)
		{
			vt m = inter(vt(0, 0), vt(1, 0), a, b);
			add(a, m);
			add(m, b);
		}
		else
			add(a, b);
	}
	sort(E, E + ept, ev_cmp);
	bool an1 = ev_cmp(E[6], E[7]);
	bool an2 = ev_cmp(E[7], E[8]);
	bool an3 = ev_cmp(E[8], E[9]);
	bool an4 = ev_cmp(E[9], E[10]);
	
	
	vt ray(1, 0);
	set<int, cmp> S = set<int, cmp>(cmp(&ray));
	vt prv(1, 0);
	double ans = 0;
	for (int i = 0; i < ept; i++)
	{
		if (!S.empty())
		{
			int r = *S.begin();
			vt a = A[r];
			vt b = B[r];
			vt r1 = prv;
			vt r2 = E[i].first;
			vt ra = inter(vt(0, 0), r1, a, b);
			vt rb = inter(vt(0, 0), r2, a, b);
			ans += (ra ^ rb) / 2.0;
		}

		vt x = E[i].first;
		int t = E[i].second;
		ray = (prv + E[i].first).norm();
		if (t >= 0)
			S.insert(t);
		else
		{
			set<int, cmp>::iterator it = S.find(~t);
			assert(it != S.end());
			S.erase(it);
		}
		prv = E[i].first.norm();
	}
	printf("%.10lf\n", ans);
}

int main() {
#ifdef LOCAL42
#define TASK "L"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int T;
	scanf("%d", &T);
	for (int i = 0; i < T; i++)
		solve();
	return 0;
}
