#include <stdio.h>
#include <math.h>
#include <string.h>
#include <memory.h>
#include <stdlib.h>
#include <ctype.h>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iostream>
using namespace std;
typedef long long LL;
typedef pair<int, int> pii;
typedef vector<int> vint;
typedef vector<string> vstr;
#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=a;i--)
#define ALL(v) v.begin(),v.end()
const int INF = 0x7FFFFFFF;
const double PI = 3.1415926535897932384626433832795;

const double EPS = 1e-8;

inline double sqr(double x) {
  return x * x;
}

struct Vector {
  double x, y;
  Vector() {}
  Vector(double x, double y) : x(x), y(y) {}

  double length2() {
    return x * x + y * y;
  }
  double length() {
    return sqrt(x * x + y * y);
  }
  Vector perp() {
    return Vector(-y, x);
  }
  Vector& normalize() {
    double len = sqrt(x * x + y * y);
    x /= len; y /= len;
    return *this;
  }

  Vector& operator += (Vector const& v) {
    x += v.x; y += v.y;
    return *this;
  }
  Vector& operator -= (Vector const& v) {
    x -= v.x; y -= v.y;
    return *this;
  }
  Vector& operator *= (double f) {
    x *= f; y *= f;
    return *this;
  }
  Vector& operator /= (double f) {
    x /= f; y /= f;
    return *this;
  }
};
Vector operator + (Vector const& a, Vector const& b) {
  return Vector(a.x + b.x, a.y + b.y);
}
Vector operator - (Vector const& a, Vector const& b) {
  return Vector(a.x - b.x, a.y - b.y);
}
Vector operator - (Vector const& a) {
  return Vector(-a.x, -a.y);
}
Vector operator * (Vector const& a, Vector const& b) {
  return Vector(a.x * b.x, a.y * b.y);
}
Vector operator * (Vector const& a, double f) {
  return Vector(a.x * f, a.y * f);
}
Vector operator * (double f, Vector const& a) {
  return Vector(a.x * f, a.y * f);
}
Vector operator / (Vector const& a, double f) {
  return Vector(a.x / f, a.y / f);
}
double dot(Vector const& a, Vector const& b) {
  return a.x * b.x + a.y * b.y;
}
double cross(Vector const& a, Vector const& b) {
  return a.x * b.y - a.y * b.x;
}

bool operator < (Vector const& a, Vector const& b) {
  if (fabs(a.x - b.x) >= EPS) return a.x < b.x;
  return a.y < b.y - EPS;
}
bool operator <= (Vector const& a, Vector const& b) {
  if (fabs(a.x - b.x) >= EPS) return a.x < b.x;
  return a.y <= b.y + EPS;
}
bool operator > (Vector const& a, Vector const& b) {
  if (fabs(a.x - b.x) >= EPS) return a.x > b.x;
  return a.y > b.y + EPS;
}
bool operator >= (Vector const& a, Vector const& b) {
  if (fabs(a.x - b.x) >= EPS) return a.x > b.x;
  return a.y >= b.y - EPS;
}
bool operator == (Vector const& a, Vector const& b) {
  return fabs(a.x - b.x) < EPS && fabs(a.y - b.y) < EPS;
}
bool operator != (Vector const& a, Vector const& b) {
  return fabs(a.x - b.x) >= EPS || fabs(a.y - b.y) >= EPS;
}

typedef Vector Point;

Point points[65536];

double area(Point* p, int n) {
  double result = 0;
  for (int i = 2; i < n; i++) {
    result += cross(p[i - 1] - p[0], p[i] - p[0]) * 0.5;
  }
  return result;
}

void test() {
  Point p;
  cin >> p.x >> p.y;
  int n;
  cin >> n;
  FOR(i, 0, n) cin >> points[i].x >> points[i].y;
  if (area(points, n) < 0) {
    reverse(points, points + n);
  }
  vector<Point> out;
  int cur = 0;
  Vector dir = points[0] - points[n - 1];
  out.push_back(points[0]);
  int behind = -1;
  for (int q = 0; q < 2; q++) for (int i = 1 - q; i < n; i++) {
    double ccur = cross(out.back() - p, points[i] - p);
    if (ccur > -EPS) {
      if (behind >= 0 && ccur > EPS) {
        double cprev = cross(out.back() - p, points[behind] - p);
        out.push_back(points[behind] + (points[i] - points[behind]) * ((0 - cprev) / (ccur - cprev)));
      }
      behind = -1;
      out.push_back(points[i]);
      dir = out.back() - out[out.size() - 2];
    } else if (cross(dir, points[i] - out.back()) > 0) {
      behind = -1;
      while (true) {
        Point top = out.back();
        out.pop_back();
        if (out.empty()) {
          cur = (cur - 1 + n) % n;
          out.push_back(points[cur]);
        }
        double cprev = cross(out.back() - p, points[i] - p);
        if (cprev > EPS) {
          out.push_back(top + (out.back() - top) * ((0 - ccur) / (cprev - ccur)));
        }
        ccur = cprev;
        if (cprev > -EPS) {
          break;
        }
      }
      out.push_back(points[i]);
      dir = out.back() - out[out.size() - 2];
    } else {
      behind = i;
    }
  }
  map<Point, int> mem;
  int first = 0, last = 0;
  for (int i = 0; i < out.size(); i++) {
    if (mem.find(out[i]) != mem.end()) {
      first = mem[out[i]];
      last = i;
    }
    mem[out[i]] = i;
  }
//  for (int i = first; i < last; i++) {
//    cout << out[i].x << " " << out[i].y << endl;
//  }
  cout << fixed << area(&out[first], last - first) << "\n";
}

int main() {
  std::ios_base::sync_with_stdio(false);
  int T;
  cin >> T;
  cout.precision(6);
  FOR(i, 0, T) test();
  return 0;
}
