#include <iostream>

using namespace std;

const int P = 11, MAXN = 100 * 1000 + 5, MOD = 998244353;
int cnt[P + 5], c[P + 5][MAXN], cs[P + 5][MAXN], dp[P + 5][(1 << P) + 5];

pair<int, int> gcd(int a, int b) {
    if(!b)
        return make_pair(1, 0);
    pair<int, int> p = gcd(b, a % b);
    return make_pair(p.second, p.first - p.second * (a / b));
}

int inv(int x) {
    return gcd(x, MOD).first;
}

int powMod(int x, int p) {
    int res = 1;
    for(int i = 0; i < p; i++)
        res = ((long long)res * x) % MOD;
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    while(true) {
        int n;
        cin >> n;
        if(!n)
            break;
        for(int i = 0; i <= P; i++)
            cnt[i] = 0;
        int bad = 0;
        for(int i = 0; i < n; i++) {
            int a;
            cin >> a;
            if(__builtin_popcount(a) != 1)
                bad++;
            else {
                int pa = 0;
                while(!(a & (1 << pa)))
                    pa++;
                cnt[pa]++;
            }
        }
        for(int i = 0; i <= P; i++) {
            c[i][0] = 1;
            for(int j = 1; j <= cnt[i]; j++)
                c[i][j] = ((((long long)c[i][j - 1] * (cnt[i] - j + 1)) % MOD) * inv(j)) % MOD;
            cs[i][cnt[i]] = c[i][cnt[i]];
            for(int j = cnt[i] - 1; j >= 0; j--)
                cs[i][j] = (c[i][j] + cs[i][j + 1]) % MOD;
        }
        for(int i = 0; i <= P + 1; i++)
            for(int j = 0; j <= (1 << P); j++)
                dp[i][j] = 0;
        dp[0][0] = 1;
        for(int i = 0; i <= P; i++)
            for(int j = 0; j <= (1 << P); j++)
                if(dp[i][j]) {
                    for(int l = 0; l <= cnt[i]; l++) {
                        int to = j + (1 << i) * l;
                        if(to >= (1 << P)) {
                            to = (1 << P);
                            dp[i + 1][to] = (dp[i + 1][to] + (long long)dp[i][j] * cs[i][l]) % MOD;
                            break;
                        }
                        dp[i + 1][to] = (dp[i + 1][to] + (long long)dp[i][j] * c[i][l]) % MOD;
                    }
                }
        cout << ((long long)((dp[P + 1][(1 << P)] + MOD) % MOD) * powMod(2, bad)) % MOD << '\n';
    }
    return 0;
}
