#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;
typedef pair<ll, ll> pl;

struct Point
{
	typedef ll pt;
	pt x, y;

	Point() : x(0), y(0)
	{
	}

	Point(pt xx, pt yy) : x(xx), y(yy)
	{
	}

	Point operator+ (const Point& p) const
	{
		return Point(x + p.x, y + p.y);		
	}
	
	Point operator- (const Point& p) const
	{
		return Point(x - p.x, y - p.y);		
	}

	pt operator* (const Point& p) const
	{
		return x * p.y - y * p.x;
	}

	pt operator% (const Point& p) const
	{
		return x * p.x + y * p.y;
	}

	pt length()
	{
		return x * x + y * y;
	}

	pt distTo(const Point& p) const
	{
		return (*this - p).length();
	}

	bool isOnLine(const Point& A, const Point& B) const
	{
		return (*this - A) * (*this - B) == 0;
	}

	bool isInSegment(const Point& A, const Point& B) const
	{
		bool onLine = isOnLine(A, B);
		bool inside = (*this - A) % (*this - B) <= 0;
		return onLine && inside;
	}

	bool isRightTurn(const Point& p) const
	{
		return *this * p <= 0;
	}

	bool isStrictRightTurn(const Point& p) const
	{
		return *this * p < 0;
	}

	bool operator==(const Point& p) const
	{
		return x == p.x && y == p.y;
	}

	bool operator!=(const Point& p) const
	{
		return x != p.x || y != p.y;
	}
};

const int MAX_N = 505;

int n;

pair<Point, ll> guards[MAX_N];
int ans[MAX_N];

int len;
pair<Point, int> pts[MAX_N];

void jarvis()
{
	int leftmost = 0;

	for (int i = 1; i < len; ++i)
	{
		if (pts[i].first.x < pts[leftmost].first.x ||
			(pts[i].first.x <= pts[leftmost].first.x && pts[i].first.y < pts[leftmost].first.y))
		{
			leftmost = i;
		}
	}

	ans[pts[leftmost].second] = 1;
	if (len == 1)
	{
		return;
	}
	Point prev = pts[leftmost].first;
	Point cur;
	int cur_ind;

	while (true)
	{
		int currr = -1;
		for (int i = 0; i < len; ++i)
		{
			if (!ans[pts[i].second] && pts[i].first != prev)
			{
				currr = i;
				break;
			}
		}
		if (currr == -1)
		{
			break;
		}
		cur = pts[currr].first;
		cur_ind = pts[currr].second;

		for (int i = currr + 1; i < len; ++i)
		{
			if (ans[pts[i].second] || pts[i].first == prev)
			{
				continue;
			}

			Point v = cur - prev;
			Point A = pts[i].first;
			Point u = A - cur;

			if (v.isRightTurn(u))
			{
				if (A.isOnLine(prev, cur))
				{
					if (!A.isInSegment(prev, cur))
					{
						cur = A;
						cur_ind = pts[i].second;
					}
				}
				else
				{
					cur = A;
					cur_ind = pts[i].second;
				}
			}
		}

		Point bst = cur - prev;
		Point cand = pts[leftmost].first - cur;

		bool f1 = bst.isStrictRightTurn(cand);
		bool f2 = cur.isInSegment(pts[leftmost].first, prev);
		if (f1 || f2)
		{
			break;
		}

		ans[cur_ind] = 1;
		prev = cur;

	}
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

    while (true)
	{
		cin >> n;
		if (n == 0)
		{
			break;
		}

		ll max_v = 0;
		for (int i = 0; i < n; ++i)
		{
			cin >> guards[i].first.x >> guards[i].first.y >> guards[i].second;
			if (guards[i].second > max_v)
			{
				max_v = guards[i].second;
			}
		}

		ZERO(ans);

		int pos = 0;
		for (int i = 0; i < n; ++i)
		{
			if (guards[i].second == max_v)
			{
				pts[pos++] = mp(guards[i].first, i);
			}
		}
		len = pos;

		jarvis();

		for (int i = 0; i < n; ++i)
		{
			for (int j = 0; j < n; ++j)
			{
				if (i != j && guards[i].first == guards[j].first && guards[i].second == guards[j].second)
				{
					ans[i] = ans[j] = 0;
				}
			}
		}

		for (int i = 0; i < n; ++i)
		{
			cout << ans[i];
		}
		cout << endl;

	}

    return 0;
}