#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <assert.h>
using namespace std;

#define EPS 1E-7
const long long MOD = 1000000007;
#define mp make_pair


struct pt2{
	int x,y;
	pt2(){};
	pt2(int _x, int _y){
		x=_x;
		y=_y;
	}
	pt2 operator -(const pt2&b){
		pt2 res;
		res.x=x-b.x;
		res.y=y-b.y;
		return res;
	}
	int operator *(const pt2&b){
		int res;
		res=x*b.y-y*b.x;
		return res;
	}
	int operator %(const pt2&b){
		int res;
		res=x*b.x+y*b.y;
		return res;
	}
};

vector<pair<pt2,int>>vec;

int dist(pt2 a, pt2 b){
	int dx=a.x-b.x;
	int dy=a.y-b.y;
	return dx*dx+dy*dy;
}


void uni(vector<pair<pt2,int>>&vec){
	vector<pair<pt2,int>>res;
	for(int i=0; i<vec.size(); ++i){
		bool ok=true;
		for(int j=i+1; j<vec.size(); ++j){
			if(vec[i].first.x==vec[j].first.x && vec[i].first.y==vec[j].first.y){
				ok=false;
				break;
			}
		}
		if(ok){
			res.push_back(vec[i]);
		}
	}
	vec=res;
}


bool cmp(pair<pt2,int> a, pair<pt2,int> b){
	return a.first.x<b.first.x || (a.first.x==b.first.x && a.first.y<b.first.y);
}

bool cw(pair<pt2,int> a, pair<pt2,int> b,pair<pt2,int> c){
	return a.first.x*(b.first.y-c.first.y)+b.first.x*(c.first.y-a.first.y)+c.first.x*(a.first.y-b.first.y)<0;
}

bool ccw(pair<pt2,int> a, pair<pt2,int> b,pair<pt2,int> c){
	return a.first.x*(b.first.y-c.first.y)+b.first.x*(c.first.y-a.first.y)+c.first.x*(a.first.y-b.first.y)>0;
}

void convex_hull(vector<pair<pt2,int>> & vec){
	if(vec.size()==1){
		return;
	}
	sort(vec.begin(),vec.end(),&cmp);
	pair<pt2,int>ptA,ptB;
	ptA=vec[0];
	ptB=vec.back();
	vector<pair<pt2,int>>up,dn;
	up.push_back(ptA);
	dn.push_back(ptA);
	for(int i=1; i<vec.size(); ++i){
		if(i==vec.size()-1 || (cw(ptA, vec[i], ptB))){
			while(up.size()>=2 && !cw(up[up.size()-2],up[up.size()-1],vec[i])){
				up.pop_back();
			}
			up.push_back(vec[i]);
		}
		if(i==vec.size()-1 || ccw(ptA, vec[i], ptB)){
			while(dn.size()>=2 && !ccw(dn[dn.size()-2],dn[dn.size()-1],vec[i])){
				dn.pop_back();
			}
			dn.push_back(vec[i]);
		}
	}
	vec.clear();
	for(int i=0; i<up.size(); ++i){
		vec.push_back(up[i]);
	}
	for(int i=dn.size()-2;i>0;--i){
		vec.push_back(dn[i]);
	}
}

int main(){
	freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	int N;
	while(cin>>N, N){
		vector<int>x(N),y(N),v(N);
		int mx=-1;
		for(int i=0; i<N; ++i){
			scanf("%d%d%d", &x[i], &y[i], &v[i]);
			mx=max(mx,v[i]);
		}
		vector<int>rep(N);
		vector<int>res(N);
		for(int i=0; i<N; ++i){
			for(int j=i+1; j<N; ++j){
				if(x[i]==x[j] && y[i]==y[j] && v[i]==mx && v[j]==mx){
					rep[i]=rep[j]=1;
				}
			}
		}
		vec.clear();

		for(int i=0; i<N; ++i){
			if(v[i]==mx){
				vec.push_back(make_pair(pt2(x[i],y[i]),i));
			}
		}
		uni(vec);
		convex_hull(vec);
		vector<int>conv(N);
		for(int i=1; i<=vec.size(); ++i){
			pt2 A=vec[i-1].first;
			pt2 B=vec[i%vec.size()].first;
			int n1=vec[i-1].second;
			int n2=vec[i%vec.size()].second;
			conv[vec[i-1].second]=1;
			for(int j=0; j<N; ++j){
				if(j==n1 || j==n2)continue;
				if(conv[j])continue;
				if(v[j]!=mx)continue;
				pt2 curr(x[j],y[j]);
				if((curr-A)*(B-A)==0 && (curr-A)%(B-A)>=0 && (curr-B)%(A-B)>=0){
					conv[j]=1;
				}
			}
		}
		for(int i=0; i<N; ++i){
			if(conv[i] && !rep[i]){
				res[i]=1;
			}
		}
		for(int i=0; i<N;++i){
			if(res[i]&&v[i]>0)printf("1");
			else printf("0");
		}
		cout<<endl;
	}


	return 0;
}