#include <iostream>
#include <cassert>
#include <map>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <cstring>
using namespace std;

template <class T> int size(const T&x) { return x.size(); }

typedef long long ll;
typedef pair<int,int> ii;
typedef vector<int> vi;

ll mod = 998244353;

ll mypow(ll a, ll b) {
    ll res = 1;
    while (b) {
        if (b & 1) {
            res = (res * a) % mod;
        }
        a = (a * a) % mod;
        b >>= 1;
    }
    return res;
}

ll mod_inv(ll a) {
    return mypow(a, mod-2);
}

ll binomial(int n, int k) {
    ll res = 1;
    for (int i = 1; i <= k; i++) {
        res *= n - (k - i);
        //res /= i;
        res %= mod;
        res *= mod_inv(i);
        res %= mod;
    }
    return res;
}

int main() {
    // ll cnt[2049];

    ll cnt[2][2049];
    ll po[2049];
    ll p2[12];
    memset(po, -1, sizeof(po));
    for (int i = 1, j = 0; i <= 2048; i *= 2, j++) {
        po[i] = j;
        p2[j] = i;
    }

    int n;
    while (scanf("%d\n", &n) != EOF && n != 0) {
        memset(cnt, 0, sizeof(cnt));

        map<int, int> m;

        //vector<int> arr(n);
        vector<ii> arr(n);
        int other = 0;
        for (int i = 0; i < n; i++) {
            ll x;
            cin >> x;
            if ((x & (x-1)) != 0) {
                other++;
            } else {
                m[x]++;
            }
        }

        for (map<int,int>::const_iterator it = m.begin(); it != m.end(); ++it) {
            arr.push_back(ii(it->first, it->second));
        }

        n = size(arr);

        cnt[1][0] = 1;
        for (int i = 0; i < n; i++) {
            int x = arr[i].first;
            int c = arr[i].second;
            for (int j = 0; j <= 2048; j++)
                cnt[i&1][j] = 0;

            for (int j = 0; j <= 2048; j++) {
                int k = 0;
                for (; k <= c && j+k*x <= 2048; k++) {
                    cnt[i&1][min(2048,j+k*x)] += (cnt[~i&1][j] * binomial(c, k)) % mod;
                    if (cnt[i&1][min(2048,j+k*x)] >= mod) {
                        cnt[i&1][min(2048,j+k*x)] -= mod;
                    }
                }

                int left = c - k + 1;

                ll add = 0;
                if (c - left < left) {
                    left = c - left;
                    for (int l = 0; l < left; l++) {
                        add += binomial(c, l);
                        if (add >= mod) {
                            add -= mod;
                        }
                    }
                    add = mypow(2, left) - add;
                    add = (add%mod + mod) % mod;
                } else {
                    for (int l = 0; l < left; l++) {
                        add += binomial(c, l);
                        if (add >= mod) {
                            add -= mod;
                        }
                    }
                }

                cnt[i&1][2048] += (cnt[~i&1][j] * add) % mod;
                if (cnt[i&1][2048] >= mod) {
                    cnt[i&1][2048] -= mod;
                }
            }
        }

        cout << cnt[~n&1][2048] << endl;

        /*
        memset(cnt, 0, sizeof cnt);
        sort(in.begin(), in.end());
        int curpow = 0;
        for(int i = 0; i < size(in); ++i){
            cout << in[i] << endl;
            if(in[i] > (1 << curpow)){
                cout << cnt[curpow] << endl;
                while(in[i] > (1 << curpow)) curpow++;
                curpow++;
                // cnt[i+1] += choose(cnt[i], 2);
                cnt[curpow+1] += (cnt[curpow]*(cnt[curpow]-1) / 2) % mod;
                cnt[curpow+1] %= mod;
            }
            cnt[curpow+1] += cnt[curpow];
            cnt[curpow+1] %= mod;
            cnt[curpow]++;
            cnt[curpow] %= mod;
        }
        for(int i = curpow; i < 11; ++i){
            cnt[i+1] += (cnt[i]*(cnt[i]-1) / 2) % mod;
            cnt[i+1] %= mod;
        }

        //printf("%d\n", cnt[13]);
        cout << cnt[11] << endl;
        cout << endl;
        in.clear();
        */
    }

    return 0;
}
