#include <iostream>
#include <set>
#include <cassert>
#include <map>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <cstring>
using namespace std;

template <class T> int size(const T&x) { return x.size(); }

typedef long long ll;
typedef pair<int,int> ii;
typedef vector<int> vi;

ll mod = 998244353;

ll mypow(ll a, ll b) {
    ll res = 1;
    while (b) {
        if (b & 1) {
            res = (res * a) % mod;
        }
        a = (a * a) % mod;
        b >>= 1;
    }
    return res;
}

ll mod_inv(ll a) {
    return mypow(a, mod-2);
}

ll binomial(int n, int k) {
    ll res = 1;
    for (int i = 1; i <= k; i++) {
        res *= n - (k - i);
        //res /= i;
        res %= mod;
        res *= mod_inv(i);
        res %= mod;
    }
    return res;
}

/*
int M(int a, int b) {
    //return ((ll)a * b) % mod;

    int res = 0;
    while (b) {
        if (b & 1) {
            res = (res + a);
            if (res >= mod)
                res -= mod;
        }

        a = a + a;
        if (a >= mod)
            a -= mod;
        b >>= 1;
    }
    return res;
}
*/

#define M(a,b) (((ll)(a)*(b))%mod)

int main() {
    // ll cnt[2049];

    ll maxinv = 3000;
    ll *inv = new ll[maxinv];
    ll *mp2 = new ll[maxinv];
    mp2[0] = 1;
    for (int i = 1; i < maxinv; i++) {
        inv[i] = mod_inv(i);
        mp2[i] = (2 * mp2[i-1]) % mod;
    }

    int cnt[2][2049];
    ll po[2049];
    ll p2[12];
    memset(po, -1, sizeof(po));
    for (int i = 1, j = 0; i <= 2048; i *= 2, j++) {
        po[i] = j;
        p2[j] = i;
    }

    int acnt[2049];
    memset(acnt, 0, sizeof(acnt));

    bool cool[2049];
    memset(cool, 0, sizeof(cool));

    for (int i = 1; i <= 2048; i *= 2) {
        cool[i] = true;
    }

    int n;
    while (scanf("%d\n", &n) != EOF && n != 0) {
        memset(cnt, 0, sizeof(cnt));

        //map<int, int> m;

        //vector<int> arr(n);
        vector<ii> arr;
        int other = 0;
        for (int i = 0; i < n; i++) {
            ll x;
            cin >> x;
            //if ((x & (x-1)) != 0 || x > 2048 || x == 0) {
            if (x > 2048 || !cool[x]) {
                other++;
            } else {
                acnt[x]++;
                //m[x]++;
            }
        }

        for (int i = 1; i <= 2048; i *= 2) {
            if (cnt[i] > 0) {
                arr.push_back(ii(i, acnt[i]));
                acnt[i] = 0;
            }
        }
        /*
        for (map<int,int>::const_iterator it = m.begin(); it != m.end(); ++it) {
            arr.push_back(ii(it->first, it->second));
        }
        */

        n = size(arr);
        //assert(n <= 12);

        cnt[1][0] = 1;
        for (int i = 0; i < n; i++) {
            int x = arr[i].first;
            int c = arr[i].second;
            for (int j = 0; j <= 2048; j++)
                cnt[i&1][j] = 0;

            for (int j = 0; j <= 2048; j++) {
                int k = 0;
                int bin = 1;
                for (; k <= c && j+k*x <= 2048; k++) {
                    //cnt[i&1][min(2048,j+k*x)] += (cnt[~i&1][j] * binomial(c, k)) % mod;
                    cnt[i&1][j+k*x] += M(cnt[~i&1][j], bin);
                    if (cnt[i&1][j+k*x] >= mod) {
                        cnt[i&1][j+k*x] -= mod;
                    }

                    bin = M(bin, c-k);
                    //bin *= mod_inv(k + 1);
                    bin = M(bin, inv[k+1]);
                }

                int left = c - k + 1;

                int add = 0;
                if (c - left < left) {
                    left = c - left;
                    int bin = 1;
                    for (int l = 0; l < left; l++) {
                        //add += binomial(c, l);
                        add += bin;
                        if (add >= mod) {
                            add -= mod;
                        }
                        bin = M(bin, c-l);
                        //bin *= mod_inv(l + 1);
                        bin = M(bin, inv[l+1]);
                    }
                    add = mp2[left] - add;
                    add = (add%mod + mod) % mod;
                } else {
                    int bin = 1;
                    for (int l = 0; l < left; l++) {
                        add += bin;
                        if (add >= mod) {
                            add -= mod;
                        }
                        bin = M(bin, c -l);
                        //bin *= mod_inv(l + 1);
                        bin = M(bin, inv[l+1]);
                    }
                }

                /*
                add = mypow(2,left-1) * binomial(c, left);
                add %= mod;
                */

                cnt[i&1][2048] += M(cnt[~i&1][j], add);
                if (cnt[i&1][2048] >= mod) {
                    cnt[i&1][2048] -= mod;
                }
            }
        }

        //cout << cnt[~n&1][2048] << endl;
        cout << M(cnt[~n&1][2048], mypow(2, other)) << endl;

        /*
        memset(cnt, 0, sizeof cnt);
        sort(in.begin(), in.end());
        int curpow = 0;
        for(int i = 0; i < size(in); ++i){
            cout << in[i] << endl;
            if(in[i] > (1 << curpow)){
                cout << cnt[curpow] << endl;
                while(in[i] > (1 << curpow)) curpow++;
                curpow++;
                // cnt[i+1] += choose(cnt[i], 2);
                cnt[curpow+1] += (cnt[curpow]*(cnt[curpow]-1) / 2) % mod;
                cnt[curpow+1] %= mod;
            }
            cnt[curpow+1] += cnt[curpow];
            cnt[curpow+1] %= mod;
            cnt[curpow]++;
            cnt[curpow] %= mod;
        }
        for(int i = curpow; i < 11; ++i){
            cnt[i+1] += (cnt[i]*(cnt[i]-1) / 2) % mod;
            cnt[i+1] %= mod;
        }

        //printf("%d\n", cnt[13]);
        cout << cnt[11] << endl;
        cout << endl;
        in.clear();
        */
    }

    return 0;
}
