#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

int n;
const int N = 505;

int v[N];
pt p[N];

bool read() {
	if (!(cin >> n))
		return false;
	
	if (n == 0)
		return false;

	forn (i, n)
		cin >> p[i].ft >> p[i].sc >> v[i];

	return true;
}

int ans[N];
int id[N];
ld R = 1e9;

#define sqr(x) ((x) * (x))

inline ld len(ld x1, ld y1, ld x2, ld y2)
{
	return sqr(x1 - x2) + sqr(y1 - y2);
}

ld f(int k, ld ang)
{
	ld tx = R * cos(ang), ty = R * sin(ang);

	ld d1 = len(p[k].ft, p[k].sc, tx, ty);
	ld d2 = 1e20;

	forn (i, n)
		if (i != k)
			d2 = min(d2, len(p[i].ft, p[i].sc, tx, ty));

	return d2 - d1;
}

bool search(int k, ld l, ld r)
{
	forn (i, 35)
	{
		ld nl = l + (r - l) / 2.3;
		ld  nr = r - (r - l) / 2.3;

		ld fl = f(k, nl);
		ld fr = f(k, nr);
		
		if (fl > EPS || fr > EPS)
			return true;

		if (fl > fr)
			r = nr;
		else
			l = nl;
	}

	return false;
}

void solve() {
	
	int m = n;

	forn (i, n)
		ans[i] = 0;

	int r = 0;
	int vmax = 0;
	forn (i, n)
		vmax = max(vmax, v[i]);

	forn (i, n)
		if (v[i] == vmax)
			p[r] = p[i], id[r] = i, r++;

	n = r;

	const int D = 6;

	forn (i, n)
	{
		forn (j, D)
		{
			if (search(i, 2 * M_PI / D * j, 2 * M_PI / D * (j + 1)))
			{
				ans[id[i]] = 1;
				break;
			}
		}
	}

	forn (i, m)
		cout << ans[i];

	cout << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while(read())
		solve();

	return 0;
}