#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

int n;
const int N = 505;

int v[N];
pt p[N];

bool read() {
	if (!(cin >> n))
		return false;
	
	if (n == 0)
		return false;

	forn (i, n)
		cin >> p[i].ft >> p[i].sc >> v[i];


	/*n = 500;
	forn (i, n)
		p[i].ft = rand(), p[i].sc = rand(), v[i] = 1;*/

	return true;
}

int ans[N];
int id[N];
ld R = 1e9;

#define sqr(x) ((x) * (x))

inline ld len(ld x1, ld y1, ld x2, ld y2)
{
	return sqr(x1 - x2) + sqr(y1 - y2);
}

int f(ld ang)
{
	ld tx = R * cos(ang), ty = R * sin(ang);

	ld d1 = 1e20;
	ld d2 = 1e20;

	int p1 = -1, p2 = -1;

	forn (i, n)
	{
		ld cur = len(p[i].ft, p[i].sc, tx, ty);
		if (cur < d1)
			d2 = d1, d1 = cur, p2 = p1, p1 = i;
		else
			if (cur < d2)
				d2 = cur, p2 = i;
	}

	return (d1 < d2 - EPS ? p1 : -1);
}

ld next(int k, ld ang)
{
	ld l = 0, r = M_PI / 2;
	if (n == 1)
		return ang;
	while (f(r + ang) == k)
		ang += r;

	forn (i, 25)
	{
		ld mid = (r + l) * 0.5;
		int nt = f(ang + mid);
		if (nt == k || nt == -1)
			l = mid;
		else
			r= mid;
	}

	return ang + r;
}

int tc = 0;

void solve() {
	
	int m = n;

	forn (i, n)
		ans[i] = 0;

	int r = 0;
	int vmax = 0;
	forn (i, n)
		vmax = max(vmax, v[i]);

	forn (i, n)
		if (v[i] == vmax)
			p[r] = p[i], id[r] = i, r++;

	n = r;

	const int D = 3;

	if (vmax != 0)
	{
		ld ang = 0.1254125;
		int ft = f(ang);
		int cur = ft;

		while(true)
		{
			if (cur == -1)
				break;
			ans[id[cur]] = 1;
			ang = next(cur, ang);
			int to = f(ang);
			cur = to;
			if (cur == ft)
				break;
		}
	}

	forn (i, m)
		cout << ans[i];

	cout << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while(read())	
		solve();

	return 0;
}