#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-15;

int n;
const int N = 505;

int v[N];
pt p[N];

bool read() {
	if (!(cin >> n))
		return false;
	
	if (n == 0)
		return false;

	forn (i, n)
		cin >> p[i].ft >> p[i].sc >> v[i];


	/*n = 500;
	forn (i, n)
		p[i].ft = rand(), p[i].sc = rand(), v[i] = 1;*/

	return true;
}

int ans[N];
int id[N];
ld R = 1e9;

#define sqr(x) ((x) * (x))

inline ld len(ld x1, ld y1, ld x2, ld y2)
{
	return sqr(x1 - x2) + sqr(y1 - y2);
}

int tc = 0;

struct line
{
	ld a, b, c;
	line (pt &v, pt &u)
	{
		a = v.sc - u.sc;
		b = u.ft - v.ft;
		c = - v.ft * a - v.sc * b;
	}
};

pair<pair<ld, ld>, pair<ld, ld> > intersect(line &l)
{
	ld A = l.a;
	ld B = l.b;
	ld C = l.c;

	ld s = sqrt(A * A + B * B);

	A /= s;
	B /= s;
	C /= s;

	ld d = C;

	if (d > R + EPS)
		assert(false);

	ld f = sqrt(ld(R) * R - d * d);

	ld x = 0 - A * d;
	ld y = 0 - B * d;

	if(fabsl(A * x + B * y + C) > EPS)
		x = A * d, y = B * d;

	assert(fabsl(A * x + B * y + C) < EPS);

	return mp(	mp(x - B * f, y + A * f),
				mp(x + B * f, y - A * f));
}
/*
pair<pair<ld, ld>, pair<ld, ld> > intersect(line &l)
{
	pair<pair<ld, ld>, pair<ld, ld> > res;
	if (l.a == 0)
	{
		ld y = -l.c / l.b;
		res.ft.sc = y, res.sc.sc = y;
	}
	else
	{
		ld d = sqrt(4 * sqr(l.b * l.c / sqr(l.a)) - 4 * (sqr(l.b / l.a) - 1) * (sqr(sqr(l.c / l.a) -R)));
		res.ft.sc = (-l.b + d) / (2 * l.a);
		res.sc.sc = (-l.b - d) / (2 * l.a);
	}

	res.ft.ft = sqrt(R * R - sqr(res.ft.sc));
	if (fabs(res.ft.ft * l.a + res.ft.sc * l.b + l.c) > EPS)
		res.ft.ft = -res.ft.ft;

	res.sc.ft = sqrt(R * R - sqr(res.sc.sc));
	if (fabs(res.sc.ft * l.a + res.sc.sc * l.b + l.c) > EPS)
		res.sc.ft = -res.sc.ft;

	//cerr << fabs(R - sqrt(sqr(res.ft.ft) + sqr(res.ft.sc))) << endl;

	return res;
}
*/
ld getAng(pair<ld, ld> &a)
{
	ld res = atan2(a.sc, a.ft);
	while (res < 0)
		res += M_PI;
	return res;
}

bool ok(ld ang, int i, int j)
{
	ld tx = R * cos(ang), ty = R * sin(ang);
	return len(tx, ty, p[i].ft, p[i].sc) < len(tx, ty, p[j].ft, p[j].sc);
}

void solve() {
	
	int m = n;

	forn (i, n)
		ans[i] = 0;

	int r = 0;
	int vmax = 0;
	forn (i, n)
		vmax = max(vmax, v[i]);

	forn (i, n)
		if (v[i] == vmax)
			p[r] = p[i], id[r] = i, r++;

	n = r;

	if (vmax != 0)
	{
		forn (i, n)
		{
			ld lf = 0, rg = INF;
			forn (j, n)
			{
				if (i == j)
					continue;
				if (p[i] == p[j])
					lf = INF;
				if (lf + EPS > rg)
					break;
				line lp = line(p[i], p[j]);
				line nl = lp;
				pair<ld, ld> m = mp((p[i].ft + p[j].ft) / 2.0, (p[i].sc + p[j].sc) / 2.0);
				nl.a = -lp.b, nl.b = lp.a;
				nl.c = -nl.a * m.ft - nl.b * m.sc;
				pair<pair<ld, ld>, pair<ld, ld> > t = intersect(nl);
				ld l = getAng(t.ft), r = getAng(t.sc);
				if (l > r)
					swap(l, r);
				if (!ok((l + r) / 2, i, j))
				{
					swap(l, r);
					r += 2 * M_PI;
				}
				lf = max(lf, l);
				rg = min(rg, r);
			}
			if (lf + EPS < rg)
				ans[id[i]] = 1;
		}
	}

	forn (i, m)
		cout << ans[i];

	cout << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while(read())	
		solve();

	return 0;
}