#include <iostream>
#include <complex>
#include <vector>
#include <algorithm>

using namespace std;
typedef long long int Z;

const Z M = 998244353;

Z modpow(Z a, Z b) {
	if(b == 0) return 1;
	if(b & 1) return a * modpow(a, b - 1) % M;
	Z x = modpow(a, b / 2);
	return x * x % M;
}
Z inv(Z x) {
	return modpow(x, M - 2);
}

Z n;
Z a[12];
Z T[12][2049];
Z fact[100005];

Z binom(Z n, Z k) {
	if(k < 0) return 0;
	if(k > n) return 0;
	return fact[n] * inv(fact[k] * fact[n - k] % M) % M;
}

int main() {
	fact[0] = 1;
	for(Z i = 1; i < 100005; ++i) {
		fact[i] = i * fact[i - 1] % M;
		fact[i] %= M;
	}

	cin.sync_with_stdio(false);
	
	while(true) {
		cin >> n;
		if(n == 0) break;
		
		Z coef = 1;
		fill(a, a + 12, 0);
		for(Z i = 0; i < n; ++i) {
			Z x;
			cin >> x;
			if(x == 0) {
				coef *= 2;
				coef %= M;
				continue;
			}
			Z e = 0;
			while(x != 1) {
				if(x & 1) {
					coef *= 2;
					coef %= M;
					break;
				}
				x >>= 1;
				++e;
			}
			if(x == 1) ++a[e];
		}
		
		T[0][0] = modpow(2, a[0]);
		for(Z i = 1; i <= 2048; ++i) {
			T[0][i] = T[0][i - 1];
			T[0][i] += M - binom(a[0], i - 1);
			T[0][i] %= M;
		}
		
		for(Z k = 1; k <= 11; ++k) {
			Z fu = modpow(2, a[k]);
			Z hee = 0;
			for(Z i = 0; i < k; ++i) hee += a[i];
			Z ga = modpow(2, hee);
			for(Z n = 0; n <= 2048; n += (1 << k)) {
				if(n != 0) {
					fu += M - binom(a[k], n / (1 << k) - 1);
					fu %= M;
				}
				
				T[k][n] = fu * ga % M;
				T[k][n] %= M;
				for(Z i = 0; i < n / (1 << k); ++i) {
					T[k][n] += binom(a[k], i) * T[k - 1][n - i * (1 << k)] % M;
					T[k][n] %= M;
				}
			}
		}
		
		
		cout << coef * T[11][2048] % M << "\n";
	}

	return 0;
}
