#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <queue>

typedef long long ll;
typedef long double ld;

using namespace std;

struct Guard
{
	int x, y, v, ind;
	bool exempt, onHull;
};

Guard guards[501];

int something(int x1, int y1, int x2, int y2) {
	return y1 * x2 - y2 * x1;
}

int main() {
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	while (true)
	{
		int n;
		cin >> n;

		if (n == 0)
			break;

		for (int i = 0; i < n; i++)
		{
			cin >> guards[i].x >> guards[i].y >> guards[i].v;
			guards[i].ind = i;
			guards[i].onHull = false;
			guards[i].exempt = false;
		}

		if (n == 1) {
			cout << ((guards[0].v > 0) ? 1 : 0) << endl;
			continue;
		}

		int maxV = 0;
		for (int i = 0; i < n; i++)
			maxV = max(maxV, guards[i].v);

		for (int i = 0; i < n; i++)
		{
			for (int j = i + 1; j < n; j++)
			{
				if (i != j && guards[i].x == guards[j].x && guards[i].y == guards[j].y && guards[i].v == guards[j].v)
				{
					guards[i].exempt = guards[j].exempt = true; // ignore these points
				}
			}
		}

		for (int i = 0; i < n; i++)
			if (guards[i].v != maxV)
				guards[i].exempt = true;

		maxV = 0;
		int idxOfMaxV = 0;
		for (int i = 0; i < n; i++)
		{
			if (guards[i].exempt)
				continue;

			maxV = max(maxV, guards[i].v);
			if (guards[i].v == maxV)
				idxOfMaxV = i;
		}

		//cout << "YAY MAX V " << maxV << endl;

		if (maxV == 0) {
			for (int i = 0; i < n; ++i)
				cout << '0';
			cout << endl;
			continue;
		}

		int lowestYXIdx = idxOfMaxV;
		if (!guards[idxOfMaxV].exempt) {
			for (int i = 0; i < n; ++i) {
				if (guards[i].exempt || guards[i].v != maxV)
					continue;

				if (guards[i].y > guards[lowestYXIdx].y)
					continue;

				if (guards[i].y == guards[lowestYXIdx].y) {
					if (guards[i].x >= guards[lowestYXIdx].x)
						continue;
				}

				lowestYXIdx = i;
			}

			guards[n] = guards[lowestYXIdx];

			set<int> chullTest;
			vector<int> chull;
			chull.push_back(lowestYXIdx);
			chullTest.insert(lowestYXIdx);
			guards[lowestYXIdx].onHull = true;

			//cout << "Corner " << lowestYXIdx << ": " << guards[lowestYXIdx].x << ";" << guards[lowestYXIdx].y << endl;

			vector<int> possible;
			while (true) {
				for (int i = 0; i < n; ++i) {
					if (guards[i].exempt || guards[i].v != maxV || chullTest.find(i) != chullTest.end())
						continue;

					int point = chull.back();

					bool fail = false;
					int v1x = guards[i].x - guards[point].x, v1y = guards[i].y - guards[point].y;
					for (int j = 0; j < n; ++j) {
						if (i == j)
							continue;
						if (j != chull.front())
							if (guards[j].exempt || guards[j].v != maxV || chullTest.find(j) != chullTest.end())
								continue;

						int v2x = guards[j].x - guards[point].x, v2y = guards[j].y - guards[point].y;

						if (something(v1x, v1y, v2x, v2y) < 0)
						{
							fail = true;
							break;
						}
					}

					if (fail)
						continue;

					possible.push_back(i);
				}

				if (possible.empty())
					break;

				int minDistIdx = 0;
				for (int i = 1; i < possible.size(); ++i) {
					// (x1 - x2)^2 + (y1 - y2)^2
					int point = chull.back();
					int dist1 = (guards[possible[minDistIdx]].x - guards[point].x) * (guards[possible[minDistIdx]].x - guards[point].x) + (guards[possible[minDistIdx]].y - guards[point].y) * (guards[possible[minDistIdx]].y - guards[point].y);
					int dist2 = (guards[possible[i]].x - guards[point].x) * (guards[possible[i]].x - guards[point].x) + (guards[possible[i]].y - guards[point].y) * (guards[possible[i]].y - guards[point].y);
					if (dist2 < dist1)
						minDistIdx = i;
				//	cout << "dist2 from " << possible[i] << " to " << point << " is " << dist2 << endl;
				}

				//cout << "Selected " << possible[minDistIdx] << ": " << guards[possible[minDistIdx]].x << ";" << guards[possible[minDistIdx]].y << endl;

				chull.push_back(possible[minDistIdx]);
				chullTest.insert(possible[minDistIdx]);
				guards[possible[minDistIdx]].onHull = true;
				possible.clear();
			}

			/*
			for (int i = 0; i < n; i++)
			{
				bool isOther = false;

				for (int j = 0; j < n; j++)
				{
					if (i != j && guards[i].x == guards[j].x && guards[i].y == guards[j].y && guards[i].v == guards[j].v)
					{
						isOther = true;
						break;
					}
				}

				if (guards[i].v == maxV && maxV != 0 && !isOther)
					cout << '1';
				else
					cout << '0';
			}
			cout << endl;
			*/
		}

		for (int i = 0; i < n; i++) {
			cout << (guards[i].onHull ? 1 : 0);
		}
		cout << endl;
	}

	return 0;
}