#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"
#define MAXN 101000

const int mod = 998244353;
const int maxv = 3000;
int n, a[MAXN], cnt[20], x[20];
int dp[20][maxv], fact[MAXN];
int inv[MAXN];

int cc[maxv];

int pow(int x, int y){
    if (y == 0) return 1;
    if (y == 1) return x % mod;
    int temp = pow(x, y / 2);
    temp = (LL(temp) * temp) % mod;
    if (y % 2) temp = (LL(temp) * x) % mod;
    return temp;
}

void init()
{
    for (int i = 0; i <= 11; i++) x[i] = 1 << i;
    fact[1] = 1;
    for (int i = 0; i < MAXN; i++)
        fact[i] = (LL(fact[i - 1]) * i) % mod;
    for (int i = 1; i < MAXN; i++)
        inv[i] = pow(i, mod - 2);
}

void readin(){
    memset(cnt, 0, sizeof(cnt));
    for (int i = 0; i < n; i++){
        scanf("%d", &a[i]);
        for (int j = 0; j <= 11; j++)
            if (a[i] == x[j]){
                cnt[j]++;
                break;
            }
    }
}

void calc(int k, int n){
    cc[0] = 1;
    cc[1] = n;
    for (int i = 2; i <= k; i++)
        cc[i] = ((LL(cc[i - 1]) * inv[i]) % mod * (n - i + 1)) % mod;
}

void process(){
    memset(dp, 0, sizeof(dp));
    calc(2048, cnt[0]);
    dp[0][1] = (pow(2, cnt[0]) - 1 + mod) % mod;
    for (int i = 2; i <= min(2048, cnt[0]); i++){
        dp[0][i] = dp[0][i - 1] - cc[i - 1];
        if (dp[0][i] < 0) dp[0][i] += mod;
    }

    int x = 1024;
    int sum = cnt[0];
    for (int i = 1; i < 12; i++){
        int s = pow(2, cnt[i]) - 1;
        calc(x, cnt[i]);
        for (int j = 1; j <= x; j++){
            dp[i][j] = (LL(s) * pow(2, sum)) % mod;
            for (int k = 0; k < j; k++)
                dp[i][j] = (dp[i][j] + (LL(cc[k]) * dp[i - 1][(j - k) * 2]) % mod) % mod;
            s -= cc[j];
            if (s < 0) s += mod;
        }
        sum = sum + cnt[i];
        x /= 2;
    }

    cout << dp[11][1] << endl;
}

bool solve()
{
    scanf("%d", &n);

    if (n == 0) return false;
    readin();
    process();

    return true;
}
 
void make(){
    freopen("output.txt", "w", stdout);
    cout << 100000 << endl;
    for (int i = 0; i < 100000; i++)
        cout << 2048 << endl;
    cout << 0 << endl;
    exit(0);
}

int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("output.txt", "r", stdin); // freopen("output.txt", "w", stdout);
    //make();
    init();
    
    
    while (solve());
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif