#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

struct pt
{
    LL x, y;
    pt() {}
    pt(LL x, LL y): x(x), y(y) {}

    friend bool operator< (const pt &a, const pt &b)
    {
        return mp(a.x, a.y) < mp(b.x, b.y);
    }

    friend pt operator-(const pt &a, const pt &b)
    {
        return pt(a.x - b.x, a.y - b.y);
    }

    friend bool operator== (const pt &a, const pt &b)
    {
        return mp(a.x, a.y) == mp(b.x, b.y);
    }
};

LL vect(const pt &a, const pt &b, const pt &c)
{
    pt ab = b - a;
    pt ac = c - a;
    return ab.x * ac.y - ab.y * ac.x;
}


vector <pt> convex_hull(vector <pt> a)
{
    vector <pt> h;
    int n = a.size();
    if (n < 2)
        return a;

    for (int i = 0; i < n; i++)
    {
        while (h.size() > 1 && vect(h[h.size() - 2], h[h.size() - 1], a[i]) > 0)
            h.pop_back();
        h.pb(a[i]);
    }
    int sz = h.size();
    for (int i = n - 2; i >= 0; i--)
    {
        while (h.size() > sz && vect(h[h.size() - 2], h[h.size() - 1], a[i]) > 0)
            h.pop_back();
        h.pb(a[i]);
    }
    h.pop_back();
    return h;
}

bool solve()
{
    int n;
    scanf("%d", &n);
    if (n == 0)
        return false;
    vector <pair<pii, int> > a(n);
    int maxV = 0;
    for (int i = 0; i < n; i++)
    {
        int x, y, v;
        scanf("%d %d %d", &x, &y, &v);
        a[i].X = mp(x, y);
        a[i].Y = v;
        maxV = max(maxV, v);
    }

    vector <pt> p;
    string ans(n, '0');
    for (int i = 0; i < n; i++)
    {
        if (a[i].Y == maxV)
            p.pb(pt(a[i].X.X, a[i].X.Y));
    }

    sort(p.begin(), p.end());
    p.erase(unique(p.begin(), p.end()), p.end());

    vector <pt> h = convex_hull(p);

    sort(h.begin(), h.end());
    vector <int> used(h.size(), -1);
    for (int i = 0; i < n; i++)
    {
        if (a[i].Y == maxV && maxV != 0)
        {
            int pos = lower_bound(h.begin(), h.end(), pt(a[i].X.X, a[i].X.Y)) - h.begin();
            if (pos != h.size() && h[pos].x == a[i].X.X && h[pos].y == a[i].X.Y)
            {
                if (used[pos] == -1)
                {
                    used[pos] = i;
                    ans[i] = '1';
                }
                else
                    ans[used[pos]] = '0';
            }
        }
    }

    cout << ans << endl;
    return true;
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    while(solve());
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif