#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

bool solve()
{
    int p;
    scanf("%d", &p);
    if (p == 0)
        return false;
    vector <pii> a(p);

    map <pii, int> m1, m2;
    for (int i = 0; i < p; i++)
    {
        for (int k = 0; k < p ; k++)
        {
            int x, y;
            scanf("%d %d", &x, &y);
            a[x].X++;
            a[y].Y++;
            m1[mp(x, y)]++;
        }
    }

    vector <pii> b(p);
    for (int i = 0; i < p; i++)
    {
        for (int k = 0; k < p; k++)
        {
            int m = i * k;

            int x = m / p;
            int y = m % p;
            b[x].X++;
            b[y].Y++;
            m2[mp(x, y)]++;
        }
    }

    vector <int> used(p * p);
    vector<int> ans(p);
    for (map<pii, int>::iterator i = m1.begin(); i != m1.end(); i++)
    {
        for (map<pii, int>::iterator k = m2.begin(); k != m2.end(); k++)
        {
            if (!used[k->X.X] && !used[k->X.Y] && i->Y == k->Y && a[i->X.X] == b[k->X.X] && a[i->X.Y] == b[k->X.Y])
            {
                ans[k->X.X] = i->X.X;
                ans[k->X.Y] = i->X.Y;
                used[k->X.X] = used[k->X.Y] = 1;
            }
        }
    }

    for (int i = 0; i < p; i++)
        printf("%d ", ans[i]);
    puts("");
    return true;
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    while(solve());
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif